% Przyklad 2.1:
% m-plik: przyklad_2_1.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 2. Podstawy analizy czestotliwosciowej i probkowanie sygnalow. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK/KD.

% 1) przygotowanie srodowiska MATLAB do uruchomienia programu:
    clc;         % czyscimy okno polecen i przesuwamy kursor do lewego-gornego naroznika tego okna;
    clear;       % oprozniamy pamiec zmiennych;
    close all;   % zamykamy wszystkie okna graficzne;

% 2) przygotowanie najwazniejszych parametrow:
    dt=0.0001;   % odstep miedzy wartosciami na osi czasu, [s];
    tmax=0.3;    % maksymalna wartosc dla przedzialu czasu, [s];
    f0=10;       % wartosc czestotliwosci, [Hz];
    A=3;         % amplituda sygnalu;
    phi=pi/2;    % faza poczatkowa [rad];

% 3) obliczenia:
    t=0:dt:tmax;          % ciag kolejnych wartosci na osi czasu, [s];
    faza=2*pi*f0*t - phi; % wyznaczamy ciag "faza", stala "pi" (=3,14...) jest wbudowana;
    x=A*cos(faza);        % korzystamy z funkcji "cos" - liczymy kolejno dla kazdej wartosci z ciagu "faza" wartosci ciagu "x";

% 4) prezentacja graficzna:
    figure(1);               % otwieramy okno graficzne numer 1;
        plot(t,x,'r.-');     % rysujemy wykres x(t) w kolorze czerwonym (r=red);
                             % kropki pokazuja polozenie punktow, z ktorych powstal wykres "ciagly";
            grid on;         % na wykresie dodajemy siatke linii poziomych i pionowych;
            xlabel('t [s]'); % dodajemy opis osi poziomej;
            
% KONIEC PRZYKLADU 2.1.