% Przyklad 2.2:
% m-plik: przyklad_2_2.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 2. Podstawy analizy czestotliwosciowej i probkowanie sygnalow. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc;         clear;        close all;
dt=0.001;    tmax=0.3;     t=0:dt:tmax;    % pseudo-ciagla os czasu;

f1=10;       f2=60;        f3=12.1;        % zadane czestotliwosci w [Hz];
p1=pi/2;     p2=pi/2;      p3=pi/4;        % zadane fazy poczatkowe w [rad];
A1=3;        A2=3;         A3=5; %         % zadane amplitudy;

x1=A1*cos(2*pi*f1*t + p1);                 % kolejne linie sa analogiczne - generuja sygnaly "ciagle";
x2=A2*cos(2*pi*f2*t + p2);
x3=A3*cos(2*pi*f3*t + p3);

Dt=0.02;     tn=0:Dt:tmax;       % wybieramy punkty probkowania dla x[n];

x1n=A1*cos(2*pi*f1*tn + p1);     % trzy kolejne linie generuja sygnaly dyskretne;
x2n=A2*cos(2*pi*f2*tn + p2);
x3n=A3*cos(2*pi*f3*tn + p3);

    figure(1); % czesc graficzna;
        subplot(3,1,1);    plot(t,x1,'r');       grid on;         hold on;
                           plot(tn,x1n,'bo');    ylabel('x1');    xlim([0,tmax]);
                           
        subplot(3,1,2);    plot(t,x2,'r');       grid on;         hold on;
                           plot(tn,x2n,'bo');    ylabel('x2');    xlim([0,tmax]);
                           
        subplot(3,1,3);    plot(t,x3,'r');       grid on;         hold on;
                           plot(tn,x3n,'bo');    xlabel('t [s]'); ylabel('x3');   
                                                                  xlim([0,tmax]);
                                 
% KONIEC PRZYKLADU 2.2.