% Przyklad 2.3:
% m-plik: przyklad_2_3.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 2. Podstawy analizy czestotliwosciowej i probkowanie sygnalow. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc;          clear;          close all;
dt=0.001;     tmax=300*dt;    t=0:dt:tmax;   % pseudo-ciagla os czasu;
Nt=length(t); x=zeros(Nt,1);                 % przygotowujemy sygnal zapelniony wartosciami zero;

T=tmax/2;     N=T/dt-1;
x0=triang(N); x(2:N+1)=x0;                   % wstawiamy do sygnalu trojkatny fragment;

a=T/2;        t0=a;                          % parametry widma na podstawie teorii;
fmax=30;      df=0.01;        f=-fmax:df:fmax;

        Nf=length(f);         kk=1:Nf;
        X1f(kk)=a*sinc(f*a).^2.*exp(-j*2*pi*f(kk)*t0);   % widmo wyliczone na podstawie teorii;
        
        for k=kk,
            X2f(k)=prosta_calka(x'.*exp(-j*2*pi*f(k)*t),t); % widmo wyliczone z danych liczbowych;
        end;
        
    figure(1);
               plot(t,x,'b.-');             grid on;     xlabel('t [s]');    title('x(t)');
                                            xlim([min(t),max(t)]);
    figure(2);
        subplot(2,2,1); 
               plot(f,abs(X1f),'r.-');      grid on;     xlabel('f [Hz]');   axis tight;  title('abs(X1(f))');
        subplot(2,2,3); 
               plot(f,angle(X1f)/pi,'c.-'); grid on;     xlabel('f [Hz]');   axis tight;  title('angle(X1(f))/pi');
        subplot(2,2,2); 
               plot(f,real(X1f),'g.-');     grid on;     xlabel('f [Hz]');   axis tight;  title('real(X1(f))');
        subplot(2,2,4); 
               plot(f,imag(X1f),'m.-');     grid on;     xlabel('f [Hz]');   axis tight;  title('imag(X1(f))');
            
    figure(3);
        subplot(2,2,1); 
               plot(f,abs(X2f),'r.-');      grid on;     xlabel('f [Hz]');   axis tight;  title('abs(X2(f))');
        subplot(2,2,3); 
               plot(f,angle(X2f)/pi,'c.-'); grid on;     xlabel('f [Hz]');   axis tight;  title('angle(X2(f))/pi');
        subplot(2,2,2);   
               plot(f,real(X2f),'g.-');     grid on;     xlabel('f [Hz]');   axis tight;  title('real(X2(f))');
        subplot(2,2,4); 
               plot(f,imag(X2f),'m.-');     grid on;     xlabel('f [Hz]');   axis tight;  title('imag(X2(f))');
            
% KONIEC PRZYKLADU 2.3.