% Przyklad 2.4: 
% m-plik: przyklad_2_4.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 2. Podstawy analizy czestotliwosciowej i probkowanie sygnalow. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc;     clear;     close all;

% najpierw tworzymy sygnal "analogowy" xa:
    dt=0.001;          tmax=300*dt;     t=0:dt:tmax;     Nt=length(t);    xa=zeros(Nt,1);
    N1=tmax/(2*dt);    x0=triang(N1);   xa(1:N1)=x0;
    
% nastepnie probkujemy:    
    K=20;            Dt=K*dt; % wyznaczamy odstep probkowania jako calkowita wielokrotnosc dt (bo tak jest najwygodniej);
    x=xa(1:K:end);            % probkujemy;
    N=length(x);              % wyznaczamy dlugosc ciagu probek;
    
% i poddajemy analizie Fouriera:    
    dF=0.0001;       F=-0.5:dF:0.5;   NF=length(F);   % okreslamy pseudo-ciagly odcinek na osi F;
    X=zeros(1,NF);            % inicjalizacja petli - wstepne wyzerowanie DTFT;
    for n=0:N-1,
         X=X+x(n+1)*exp(-j*2*pi*F*n);     % dodajemy do DTFT czesci pochodzace od kolejnych x[n];
    end;
    
        font_size_1=14;       % zmiana tej wartosci zmieni wielkosc czcionki w wybranych elementach opisu; 
        figure(1);  % te ilustracje warto rozciagnac na caly ekran;
            subplot(3,1,1); 
                    plot((N-1)*t/tmax, xa, 'r');   grid on;   hold on;
                    stem(0:N-1,x);
                        title('x[n]','fontsize',font_size_1);        xlabel('n','fontsize',font_size_1);
                    
            subplot(3,2,3); 
                    plot(F,abs(X),'r.-'); grid on; 
                        xlim([-0.5,0.5]);                            title('abs(X)','fontsize',font_size_1);
                    
            subplot(3,2,5); 
                    plot(F,angle(X)/pi,'c.-'); grid on;     
                        title('angle(X)/pi','fontsize',font_size_1); xlabel('F','fontsize',font_size_1);
                        xlim([-0.5,0.5]);
                    
            subplot(3,2,4); 
                    plot(F,real(X),'g.-');     grid on;
                        title('real(X)','fontsize',font_size_1);
                        xlim([-0.5,0.5]);
                    
            subplot(3,2,6); 
                    plot(F,imag(X)/pi,'m.-'); grid on; 
                        title('imag(X)','fontsize',font_size_1);     xlabel('F','fontsize',font_size_1); 
                        xlim([-0.5,0.5]);
                    
% KONIEC PRZYKLADU 2.4.                    