% Przyklad 2.5:
% m-plik: przyklad_2_5.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 2. Podstawy analizy czestotliwosciowej i probkowanie sygnalow. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

    clc;    clear;  close all;
    
    fpr=22025; dt=1/fpr; tmax=0.5; t=0:dt:tmax;  % probkowana os czasu;
    f1=440,    f2=2*440,                         % warto dla porownania podstawic: f2=fpr-f1,
    
    x1=cos(2*pi*f1*t);
    x2=cos(2*pi*f2*t);
    
    n0=1000; n=(1:100)+n0;              % wybor indeksow na potrzeby wykresu;
    
        figure(1);                      % poczatek czesci graficznej;
            plot(t(n),x1(n),'bs-');     grid on;    hold on;
            plot(t(n),x2(n),'ro-');
                    xlabel('t [s]');    % opis osi poziomej;
                    axis tight;         % ograniczamy wykres do "istotnego" zakresu;
                    
                    
        x=[x1,x2,x1,x2,x1,x2];                   % laczymy kolejno elementy sygnalu;
        wavwrite(x,fpr,16,'moja_muzyka_1.wav');  % zapis sygnalu do pliku (wczytanie przez "wavread");
        sound(x,fpr);                            % przesylamy sygnal do karty dzwiekowej;
        
% KONIEC PRZYKLADU 2.5.