% Przyklad 2.8: 
% m-plik: przyklad_2_8.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 2. Podstawy analizy czestotliwosciowej i probkowanie sygnalow. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc;     clear;    close all;

N1=2^4-1;
x=mod(0:N1-1,5);                                 % przykladowy ciag probek (warto zmienic);

X1=fft(x);                                       % wyznaczamy DFT;

K=32; N2=K*N1;                                   % zakladamy wydluzenie ciagu K+1 razy;
X2=fft(x,N2);                                    % przyblizone wyznaczanie DTFT;

fpr=10;   df1=fpr/N1;    df2=fpr/N2;             % potrzebne do opisu osi DFT oraz DTFT w Hz;
f1=0:df1:(N1-1)*df1; f2=0:df2:(N2-1)*df2;        % wektory opisu osi DFT oraz DTFT w Hz;

sX1=fftshift(X1);                                % przestawienie elementow DFT;
if N1/2==round(N1/2),                            % dla N1 parzystych;
    sf1=[f1(N1/2+1:end)-fpr,f1(1:N1/2)];         % opracowanie opisu osi poziomej w Hz;
else                                             % dla N1 nieparzystych;
    sf1=[f1((N1+1)/2+1:end)-fpr,f1(1:(N1+1)/2)]; % opracowanie opisu osi poziomej w Hz
end;

sX2=fftshift(X2);                                % przestawienie elementow przyblizenia DTFT;
if N2/2==round(N2/2),
    sf2=[f2(N2/2+1:end)-fpr,f2(1:N2/2)];         % opracowanie opisu osi poziomej w Hz;
else
    sf2=[f2((N2+1)/2+1:end)-fpr,f2(1:(N2+1)/2)]; % opracowanie opisu osi poziomej w Hz
end;

    figure(1); % te ilustracje warto rozciagnac na caly ekran;
        subplot(3,1,1); 
                stem(0:N1-1,x);         xlim([0,N1-1]);         grid on;
                    set(gca,'fontsize',12,'xtick',0:N1-1);      xlabel('n','fontsize',18,'fontangle','italic');
                    
        subplot(3,1,2); 
                plot(f2,abs(X2),'b.-');         grid on;        hold on;
                plot(f1,abs(X1),'ro','linewidth',2,'markerface','r');
                    set(gca,'fontsize',12);     xlabel('f [Hz]','fontsize',18,'fontangle','italic');
                    legend('DTFT','DFT');
                    
        subplot(3,1,3); 
                plot(sf2,abs(sX2),'b.-');       grid on;        hold on;
                plot(sf1,abs(sX1),'ro','linewidth',2,'markerface','r');
                    set(gca,'fontsize',12);     xlabel('f [Hz]','fontsize',18,'fontangle','italic');
                    legend('DTFT','DFT');      
                    
% KONIEC PRZYKLADU 2.8.