% Przyklad 2.9: 
% m-plik: przyklad_2_9.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 2. Podstawy analizy czestotliwosciowej i probkowanie sygnalow. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc;     clear;    close all;

N=1024;     M=32;       dM=4;   fpr=100;    % wartosci parametrow;
Df=5;       dt=1/fpr;   f0=25;              % wartosci parametrow (cd.);
t=0:dt:(N-1)*dt;                            % os czasu;
p=2*pi*(f0+0.5*Df*t).*t;                    % faza zalezna od czasu;
x=cos(p);   x=x(:);     XN=fft(x);          % sygnal i jego calosciowe DFT;
w=hamming(M);   k=0;                        % okno i inicjalizacja licznika;

    for m0=1:dM:N-M+1;    k=k+1;
        x1=x(m0:m0+M-1);  x2=x1.*w;          % kolejne bloki i mnozenie przez okno;
        X1(:,k)=fft(x1);  X2(:,k)=fft(x2);   % kolejne transformaty DFT;
    end;
    
f=(0:M/2)*fpr/M; fN=(0:N/2)*fpr/N; n=(1:dM:N-M+1)+M/2;  % przygotowanie dla wykresow;
  
    fs_1=14;  fs_2=12; % dwie wielkosci czcionek (font size);
  
    figure(1); % te ilustracje warto rozciagnac, ale nie na caly ekran, tylko troche; 
           % Uwaga - opisy osi wykresow 3D (mesh) moga sie pojawic troche za nisko;
            subplot(3,1,1);
                plot(fN,abs(XN(1:N/2+1)),'ko');        grid on;
                    xlabel('f [Hz]','fontsize',fs_1);  title('abs(X_N)','fontsize',fs_1);
                    set(gca,'fontsize',fs_2);
                    
            subplot(3,2,3);
                mesh(t(n),f,abs(X1(1:M/2+1,:)));       axis tight;      view([-30,15]);
                    xlabel('t [s]','fontsize',fs_1);   ylabel('f [Hz]','fontsize',fs_1);
                    title('abs(X_1)','fontsize',fs_1); set(gca,'fontsize',fs_2);
                    
            subplot(3,2,4);
                mesh(t(n),f,abs(X2(1:M/2+1,:)));       axis tight;      view([-30,15]);
                    xlabel('t [s]','fontsize',fs_1);   ylabel('f [Hz]','fontsize',fs_1);
                    title('abs(X_2)','fontsize',fs_1); set(gca,'fontsize',fs_2);
                    
            subplot(3,2,5);
                mesh(t(n),f,abs(X1(1:M/2+1,:)));       axis tight;      view([0,90]);
                    xlabel('t [s]','fontsize',fs_1);   ylabel('f [Hz]','fontsize',fs_1);
                    title('abs(X_1)','fontsize',fs_1); set(gca,'fontsize',fs_2);
                    
            subplot(3,2,6);
                mesh(t(n),f,abs(X2(1:M/2+1,:)));       axis tight;      view([0,90]);
                    xlabel('t [s]','fontsize',fs_1);   ylabel('f [Hz]','fontsize',fs_1);
                    title('abs(X_2)','fontsize',fs_1); set(gca,'fontsize',fs_2);
                    
                    colormap(gray(256)); % wszystkie wykresy beda teraz "na szaro";

% KONIEC PRZYKLADU 2.9.