% Przyklad 3.1:
% m-plik: przyklad_3_1.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 3. Sygnaly losowe i szumy. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Adam Borowicz, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc; clear; close all;                      % posprzatanie "biurka";

N=2^10;     K=2^14;                         % N-dlugosc ciagu; K-liczba realizacji;
mu=3;       sigma=4;                        % zalozone, czyli dokladne, parametry rozkladu;

X=randn(K,N)*sigma+mu;                      % generowanie kompletu danych (ciagi ergodyczne);
mx=mean(X);   sx1=std(X);   sx2=std(X,1);   % szacowanie parametrow dla kolejnych "n";

[hx,bx]=hist(X(:),100);     dx=bx(2)-bx(1); % wyliczanie histogramu i szerokosci jednego "slupka";
[hmx,bmx]=hist(mx,100);                     % wyliczanie histogramu dla mx;
[hsx,bsx]=hist(sx1,100);                    % wyliczanie histogramu dla sx1 (estymator nieobciazony);

msx1=mean(sx1),  msx2=mean(sx2),            % wartosci srednie dla rozkladow sx1 i sx2;
smx=std(mx),     smx_ref=sigma/sqrt(K),     % porownanie odchylenia standardowego dla mx z teoria;

    figure(1);                              % przyklad "surowego" opracowania graficznego:
        subplot(311); bar(bx,hx/(sum(hx)*dx),1);         grid on; hold on;
                      plot(bx,normpdf(bx,mu,sigma),'r-');
                        legend('rozklad teoretyczny','skalowany histogram');
        subplot(312); bar(bmx,hmx,1);                    grid on;
                        legend('histogram wartosci sredniej');        
        subplot(313); bar(bsx,hsx,1);                    grid on;
                        legend('histogram odchyl. stand.');        
        
% KONIEC PRZYKLADU 3.1.