% Przyklad 3.2:
% m-plik: przyklad_3_2.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 3. Sygnaly losowe i szumy. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Adam Borowicz, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc; clear; close all;  % Patrz Przyklad 3.1;

N=2^8;      K=2^10;     % Patrz Przyklad 3.1;
wersja=1;               % wybor sposobu generowania danych (1,2 lub 3);
switch wersja,
    case 1, mu=3;   sigma=4;     X=randn(K,N)*sigma+mu;
    case 2, X=cos(ones(K,1)*2*pi*4*(0:N-1)/N + rand(K,1)*ones(1,N)*2*pi);
    case 3, mu=3;   sigma=4;     X=randn(K,N)*sigma+mu;
            M=5;    h=rand(1,M); X=filter(h,1,X);
end;

[H,b]=hist(X,100);      % wyznaczone zbiorczo histogramy (dla kolejnych realizacji);

opcja=1;                % wybor sposobu wyliczania;
switch opcja,
    case 1, for k=1:K, CX(k,:)=xcorr(X(k,:),X(k,:)); end;     % wyliczamy rxx bez korekty;
    case 2, m=-(N-1):N-1;                                     % wariant z korekta;
            for k=1:K, CX(k,:)=xcorr(X(k,:),X(k,:))./(N-abs(m)); end; 
end;

    figure(1); 
            mesh(0:N-1,b,H);  title('wykres 3D z histogramami dla kolejnych realizacji procesu');
                axis tight;   xlabel('numer realizacji');  ylabel('x');
    figure(2); 
            mesh(CX);         title('wykres r_x_x dla kolejnych realizacji procesu');
                axis tight;   xlabel('m');                 ylabel('numer realizacji');
                
% KONIEC PRZYKLADU 3.2.