% Przyklad 4.1:
% m-plik: przyklad_4_1.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 4. Projektowanie filtrow. 
% Autorzy rozdzialu: Krzysztof Duda, Przemyslaw Korohoda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./KD.

close all, clear all, clc

Ba = [1];                   %wspolczynniki wielomianu licznika H(s)
Aa = [1 sqrt(2) 1];         %wspolczynniki wielomianu mianownika H(s)
Bd = [0.12858 0];           %wspolczynniki wielomianu licznika H(z)  
Ad = [1 -1.4225 0.55301];   %wspolczynniki wielomianu mianownika H(z)

%% odpowiedz czestotliwosciowa H(s) w Matlabie funkcja freqs
w = 0:0.1:5;   %zakres czestotliwosci w [rad/s]
s = j*w;
HBa = polyval(Ba,s); 
HAa = polyval(Aa,s);
Ha  = HBa./HAa; 
%% odpowiedz czestotliwosciowa H(z) w Matlabie funkcja freqz
Om = 0:0.05:pi;   %zakres czestotliwosci w [rad]
z = exp(j*Om);
HBd = polyval(Bd,z); 
HAd = polyval(Ad,z);
Hd  = HBd./HAd; 
%% zera i bieguny
[za,pa,ka] = tf2zp(Ba,Aa);
[zd,pd,kd] = tf2zp(Bd,Ad);
%% wykresy
figure   
subplot(2,2,1)
    plot(w, abs(Ha),'.-'), 
    xlabel('\omega (rad/s)'), ylabel('|H(s)|')    
    axis tight,box on        
subplot(2,2,2)
    plot(Om, abs(Hd),'.-')
    xlabel('\Omega (rad)'), ylabel('|H(z)|')
    axis tight,box on        
subplot(2,2,3), hold on   
    v = [-1.3 1.3 -1 1]; %zakres osi
    plot(real(pa), imag(pa),'xb')
    legend('bieguny H(s)')
    plot([0 0],[v(3) v(4)],'-k') %os OY
    plot([v(1) v(2)],[0 0],'-k') %os OX    
    xlabel('Re'), ylabel('Im')
    axis(v), box on, axis equal
subplot(2,2,4), hold on       
    plot(real(zd), imag(zd),'ob')
    plot(real(pd), imag(pd),'xb')
    legend('zera H(z)','bieguny H(s)')
    plot([0 0],[v(3) v(4)],'-k') %os OY
    plot([v(1) v(2)],[0 0],'-k') %os OX
    O = -pi:0.01:pi; O = exp(j*O);
    plot(real(O),imag(O),'-k')   %okrag
    xlabel('Re'), ylabel('Im')    
    axis(v), box on, axis equal
    
% KONIEC PRZYKLADU 4.1.