% Przyklad 4.5:
% m-plik: przyklad_4_5.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 4. Projektowanie filtrow. 
% Autorzy rozdzialu: Krzysztof Duda, Przemyslaw Korohoda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc; clear; close all;

M=11; n=0:M; d=0.25;            % okreslamy rzad filtra, indeksy dla h[n] oraz opoznienie ulamkowe;
h1=sinc(n-(M+1)/2+d);           % wyliczamy h1[n] dla filtra wedlug (4.71);

w=hamming(M+1);                 % wyliczamy wartosci okna Hamminga;
h2=h1.*w';                      % mnozymy h1[n] przez wspolczynniki okna;

[H1,W]=freqz(h1,1,10000); F=W/(2*pi);   % wyznaczamy DTFT dla h1[n];
dF=F(2)-F(1); P1=unwrap(angle(H1));     % wyliczamy przyrost na osi F oraz ch-ke fazowa;

D10=-P1(2:end)./F(2:end);        % wyliczamy opoznienie fazowe;
D1=D10/(2*pi);                  % ... i przeliczamy na opoznienie w indeksach;
G10=-(P1(2:end)-P1(1:end-1))/dF; % wyliczamy opoznienie grupowe;
G1=G10/(2*pi);                  % ... i przeliczamy na opoznienie w indeksach;

    figure(1);
        plot(0:M,h2,'bo-'); grid on;    axis tight
                xlabel('n'); legend('elementy odpowiedzi impulsowej h1[n]');
        
    figure(2);
        subplot(4,1,1); plot(F,abs(H1),'b.-');          grid on;
                            legend('DTFT: modul(H1)',0);
        subplot(4,1,2); plot(F,angle(H1)/pi,'b.-');     grid on;
                            legend('DTFT: faza(H1)/pi',0);        
        subplot(4,1,3); plot(F(1:end-1)+dF/2,D1,'b.-'); grid on;
                            legend('opoznienie fazowe dla h1',0);
        subplot(4,1,4); plot(F(1:end-1)+dF/2,G1,'b.-'); grid on; 
                            legend('opoznienie grupowe dla h1',0);  xlabel('F');

                            
% analogicznie dla h2, a nastepnie wykresy - ale to juz prosze wykonac samodzielnie...

% KONIEC PRZYKLADU 4.5.