% Przyklad 4.7:
% m-plik: przyklad_4_7.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 4. Projektowanie filtrow. 
% Autorzy rozdzialu: Krzysztof Duda, Przemyslaw Korohoda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc; clear; close all;  % porzadki wstepne;

Tb=0.01;                % czas trwania pojedynczego symbolu;
M=200; K=20;            % zalozony rzad filtra oraz liczba probek na symbol;
a=0.5;                  % parametr pasma przejsciowego filtra;
fpr=K/Tb;               % czestotliwosc probkowania;
Df=a/Tb;                % szerokosc pasma przejsciowego filtra;
h0 = firrcos( M, 1/(2*Tb), Df, fpr);         % MATLAB: 1. sposob;
h1 = firrcos( M, 1/(2*Tb), a, fpr,'rollof'); % MATLAB: 2. sposob;
%% wzor (4.74):
n=0:M; Nd=M/2;          % indeksy oraz wartosc opoznienia;
h2 = sinc((n-Nd)/K).* cos(pi*a*(n-Nd)/K)./(1-4*a^2*(n-Nd).^2/K^2);
n0=find((1-4*a^2*(n-Nd).^2/K^2)==0); % wzor moze dac dzielenie 0/0;
h2(n0)=0;               % wartosc graniczna, gdy ze wzoru wynika 0/0;
h2=h2/K;                % normalizacja;
err_0=max(abs(h0-h1)),  % weryfikacja nr 1;
err_1=max(abs(h1-h2)),  % weryfikacja nr 2;
[H,W]=freqz(h2,1,1000); % wyliczenie DTFT, czyli charakterystyk filtra;
F=W/(2*pi); f=F*fpr;    % przeliczenie W na F (czestotl. unormowana) oraz na f [Hz];

    figure(1);
        plot(0:M,h2,'bo-'); grid on;
            legend('odp. impulsowa h2');  xlabel('n');
    figure(2);
        subplot(211);
            plot(f,abs(H),'b.-');       grid on;  legend('DTFT: modul(H)',0);    title('Warto powiekszyc wybrane fragmenty');
        subplot(212);
            plot(f,angle(H)/pi,'r.-');  grid on;  legend('DTFT: faza(H)/pi',0);  xlabel('f [Hz]');
        

% KONIEC PRZYKLADU 4.7.