% Przyklad 4.8:
% m-plik: przyklad_4_8.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 4. Projektowanie filtrow. 
% Autorzy rozdzialu: Krzysztof Duda, Przemyslaw Korohoda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clear; close all; clc;          % przygotowanie "biurka" do pracy;
Fg=0.01; Fz=0.012;              % czestotliwosci graniczne filtra;
A_dB=60;                        % tlumienie w pasmie zaporowym w dB;
NF=100000;                      % liczba punktow na osi F do wylicz. ch-k;

M=round(1/(Fg+Fz+sqrt(Fz-Fg))), % wyliczamy krotnosc nadprobkowania;
Nref=round(A_dB/(22*(Fz-Fg))),  % wyliczamy rzad filtra "ref";

Wref=[1,10];                    % wagi dla procedury "remez";
Aref=[1,1,0,0];                 % amplitudy docelowe dla funkcji "remez";
Fref=[0,Fg,Fz,0.5]*2;           % wektor czestotl. dla funkcji "remez";
href=remez(Nref,Fref,Aref,Wref);        % wyznaczamy odpowiedz imp. filtra "ref";
[Href,W]=freqz(href,1,NF); F=W/(2*pi);  % wyliczamy ch-ki filtra "ref";
Fprot=[0,Fg*M,Fz*M,0.5]*2;      % wektor czestotl. dla funkcji "remez";

Nprot=floor(Nref/M),            % wyliczamy rzad filtra "prot";
hprot=remez(Nprot,Fprot,Aref,Wref);     % wyznaczamy odp. imp. filtra "prot";

hnp=zeros(1,M*Nprot+1); hnp(1:M:end)=hprot; % nadprobkowanie;
Hnp=freqz(hnp,1,NF);            % ch-ki filtra po nadprobkowaniu (F=Fref);

Fintrp_z=1/M-Fz; Fintrp_g=Fg;   % czestotliwosci graniczne dla filtra "intrp";
Fintrp=[0,Fintrp_g,Fintrp_z,0.5]*2;     % wektor czest. dla funkcji "remez";
Nintrp=round(A_dB/(22*(Fintrp_z-Fintrp_g))), % wyliczamy rzad filtra "intrp";
hintrp=remez(Nintrp,Fintrp,Aref,Wref);  % wyznaczamy odp. imp. filtra "intrp";
Hintrp=freqz(hintrp,1,NF);      % ch-ki filtra "intrp" (F=Fref);

H_IFIR=Hnp.*Hintrp;             % efekt zastepczy filtracji dwuetapowej;

Oszczednosc_w_procentach=100*(Nref-Nintrp-Nprot)/Nref,
        
        figure(1);
            subplot(2,1,1);
                    plot(F,abs(H_IFIR),'b.-');         grid on;   hold on;
                    plot(F,abs(Href),'r.-');
                           xlim([0,0.012]);  
                           title('DTFT: modul(H)');    legend('H_I_F_I_R','H_r_e_f',0);
            subplot(2,1,2);
                    plot(F,angle(H_IFIR)/pi,'b.-');    grid on;   hold on;
                    plot(F,angle(Href)/pi,'r.-');
                           xlim([0,0.012]);  
                           title('DTFT: faza(H)/pi');  legend('H_I_F_I_R','H_r_e_f',0);
                           xlabel('F');
                    
% KONIEC PRZYKLADU 4.8.