 % Przyklad 5.1 - Algorytm FFT z podzialem w czasie (DIT)
 function Xw=fft_dit(xt);
 N=length(xt);
 %% uzupelnienie zerami do dlugosci 2^v
 v=ceil(log2(N)); %liczba bitow
 xt=[xt zeros(1,2^v-N)];
 N=length(xt);
 %% odwrocenie kolejnosci bitow indeksowanie od 0
 xo= zeros(size(xt)); %inicjalizacja zmiennej
 b = 2.^(v-1:-1:0); %wagi binarne
 for k=0:N-1;
	 ind=k;
	 ko=zeros(1,v);
	 for k1=0:v-1
		 if ind-b(k1+1)>=0
			 ko(k1+1)=1; ind=ind-b(k1+1);
		 end
	 end
	 ind_o=sum(fliplr(ko).*b);
	 xo(ind_o+1)=xt(k+1);
 end
 %% algorytm FFT
 X=zeros(2,N); %pamiec dla danych i wynikow
 X(1,:)=xo; %dane
 WN=exp(-j*2*pi/N);
 for k=0:v-1 %petla po etapach
	 M=2^k; %liczba motylkow w bloku
	 for k1=0:N/2/M-1; %petla po blokach
		 for k2=0:M-1; %petla wewnatrz bloku
		 %ustalenie indeksow
		 p=k1*N/2^(v-k-1)+k2;
		 q=p+M;
		 r=2^(v-k-1)*k2;
		 %obliczenia motylkowe
		 X(2,p+1)=X(1,p+1)+WN^r*X(1,q+1);
		 X(2,q+1)=X(1,p+1)-WN^r*X(1,q+1);
		 end
	 end
	 X(1,:)=X(2,:); %obliczenia z podstawianiem
 end
 Xw=X(1,:);
