clear all, close all, clc

N=32;         %liczba probek sygnalu

n = 0:N-1;
x=cos(5.5*(2*pi/N)*n)+0.1*randn(1,N);    %przykladowy sygnal testowy
X1=fft(x);      k1=0:N-1;
X2=fft_dit(x);  k2=0:length(X2)-1;

if length(X2)==N
    blad = max(abs(X1-X2))
end

figure
    plot(n, x,'.-b')        
    xlabel('n')    
    ylabel('x_n')    
    title('Sygnal testowy')    
    box on, axis tight
    
figure, hold on
subplot(3,1,1), hold on
    plot(k1, abs(X1),'.-b')
    plot(k2, abs(X2),'o-r')
    xlabel('k')    
    title('Modul')
    legend('fft','fft_dit')
    box on, axis tight
subplot(3,1,2), hold on
    plot(k1, real(X1),'.-b')
    plot(k2, real(X2),'o-r')
    xlabel('k')    
    title('Czesc rzeczywista')
    legend('fft','fft_dit')
    box on, axis tight
subplot(3,1,3), hold on    
    plot(k1, imag(X1),'.-b')
    plot(k2, imag(X2),'o-b')
    xlabel('k')
    title('Czesc urojona')
    legend('fft','fft_dit')
    box on, axis tight
    