% Przyklad 5.5
  close all, clear all, clc
  
  Nh = 512; Nx = 10*Nh;             % dlugosc filtra, dlugosc sygnalu
  Nb = Nh;                          % dlugosc bloku probek sygnalu
  x=randn(1,Nx); h=0.99.^(0:Nh-1);  % sygnal 1 = losowy, sygnal 2 = odp. impulsowa filtra
  y1 = conv(x,h);                   % wynik splotu funkcja Matlaba jako odniesienie

% Metoda czwarta: sekcjonowany szybki splot overlap-add #1 (dodawanie sygnalow na wyjsciu)
  Lb = ceil(Nx/Nb);                      % liczba blokow
  hzz = [h zeros(1,Nb-Nh) zeros(1,Nh)];  % wypelnianie h zerami
  Hz = fft(hzz);                         % FFT odpowiedzi impulsowej
  y4 = zeros(1,Nh-1);                    % przygotowanie wektora y4
  for k = 1:Lb
      bx = x((k-1)*Nb+1:k*Nb);           % wycinanie bloku Nb probek sygnalu x[n]
      bxz = [bx zeros(1,Nh)];            % uzupelnianie zerami do dlugosci Nb+Nh-1
      Bxz = fft(bxz);                    % FFT fragmentu sygnalu
      by = real( ifft( Bxz.*Hz ) );      % iloczyn widm i IFFT
      y4(end-(Nh-2):end) = y4(end-(Nh-2):end)+ by(1:Nh-1);  % dodawanie koniec + poczatek
      y4 = [ y4 by(Nh:end-1)];           % wstawianie probek na koniec wynikowego wektora
  end;
  blad4 = max(abs(y1-y4))                % blad

% Metoda piata: sekcjonowany szybki splot overlap-add #2 (dodawanie widm na wejsciu)
  Lb = ceil(Nx/Nb);                      % liczba blokow probek
  hzz = [h zeros(1,Nb-Nh) zeros(1,Nb)];  % wypelnianie h zerami Nb+Nb
  Hz = fft(hzz);                         % FFT odpowiedzi impulsowej
  J = (-1).^(0:2*Nb-1);                  % J = macierz korekcji opoznienia w widmie X2
  X2 = zeros(1,2*Nb); y5 = [];           % przygotowanie wektora y5
  for k = 1:Lb
      x1 = x((k-1)*Nb+1:k*Nb);           % wycinanie bloku Nb probek sygnalu x[n]
      xx = [x1 zeros(1,Nb)];             % uzupelnianie zerami do dlugosci Nb+Nh
      X1 = fft(xx);                      % FFT
      X = X1 + J.*X2; X2 = X1;           % dodawanie widm X1 i X2 (z korekcja opoznienia)
      yy = real( ifft( X.*Hz ) );        % iloczyn widm, nastepnie IFFT
      y5 = [ y5 yy(1:Nb)];               % wstawianie probek na koniec wynikowego wektora
  end;
  blad5 = max(abs(y1(1:length(y5))-y5))  % blad

% Metoda szosta: sekcjonowany szybki splot overlap-add #3 z dodatkowym podzialem h
% na bloki (fragmenty) o rownej dlugosci
  Nb = 32;             % arbitralnie przyjeta dlugosc bloku probek x[n] i h[n]
  Lb = ceil(Nx/Nb);    % liczba blokow sygnalu
  Lh = ceil(Nh/Nb);    % liczba blokow odpowiedzi impulsowej filtra
  for k = 1:Lh         % obliczenie macierzy H (widma fragmentow odpowiedzi impulsowej) 
      H(k,1:2*Nb) = fft( [h((k-1)*Nb+1:k*Nb) zeros(1,Nb)] ); % uzupelnianie zerami, FFT
  end
  bx = zeros(1,2*Nb); X = zeros(Lh,2*Nb); y6 = [];
  for k = 0 : Lb-1
      bx = [ bx(Nb+1:2*Nb) x(k*Nb+1:k*Nb+Nb) ]; % pobierz kolejny blok probek x[n]
      X = [ fft(bx); X(1:Lh-1,:) ];      %  oblicz jego FFT, zmodyfikuj macierz X
                                         % (w wierszach widma fragmentow sygnalu x)
      XH = X.*H;                         % iloczyn elementow macierzy widm X i H
      by = real( ifft( sum(XH) ) );      % sumowanie, potem IFFT 
      y6 = [ y6 by(Nb+1:2*Nb) ];         % wstawianie probek na koniec wynikowego wektora
  end
  blad6 = max(abs(y1(1:length(y6))-y6))  % blad

% Metoda siodma: sekcjonowany szybki splot overlap-add #4 z dodatkowym podzialem h
% na bloki (fragmenty) o nierownej dlugosci - male opoznienie sygnalu na wyjsciu

  N = 32;                  % rozmiar pierwszego, najkrotszego fragmentu h
  max_index = Nh/(4*N);    % dlugosc najdluzszego fragmentu h (wyrazona w wielokrotnosci 4N)
  H = zeros((log2(max_index)+1)*2, Nh/2);  % inicjalizacja macierzy H widm FFT fragmentow h
  Lb = size(H,1);          % liczba fragmentow (blokow) h        
  y7 = zeros(1,Nx+2*Nh-1);

% Podzial odpowiedzi impulsowej filtra
  i=1; k=1;
  while i<=Lb              
     H(k  ,1:i*N) = h(2*N*i+1 : 2*N*i+N*i);   % bloki wag filtra sa wpisywane do macierzy
     H(k+1,1:i*N) = h(3*N*i+1 : 3*N*i+N*i);   % o wymiarze: Nh/2 x log2(max_index)
     i=i*2; k=k+2;              
  end

% FFT fragmentow odp. impulsowej filtra (w jednym obiegu petli liczymy dwa widma)   
  i=1;
  for k=1:2:size(H,1) 
      H(k,  1:2*i*N) = fft(H(k,   1:2*i*N));  % kazdy odcinek jest wypelniony zerami do 
      H(k+1,1:2*i*N) = fft(H(k+1, 1:2*i*N));  % dl 2*dlugosc odcinka
      i=i*2;
  end;

% Glowna petla  
  x = [ x zeros(1,Nh-1) ];   % uzupelnienie sygnalu zerami
  for n = 1 : Nx+Nh-1        % powtarzamy do konca sygnalu
      i = 1;
    % Pierwszy fragment odpowiedzi impulsowej filtra - metoda bezposrednia
      if n<2*N
         splot = h(n:-1:1)*(x(1:n))';           % splot w dziedzinie czasu
      else
         splot = h(2*N:-1:1)*(x(n-2*N+1:n))';   % splot w dziedzinie czasu
      end
      y7(n) = y7(n)+splot;
    % Kolejne fragmenty odpowiedzi impulsowej filtra - metoda blokowa
      k = 1;
      while(i <= max_index)
        if mod(n,i*N)==0                   % czy mamy odp. liczbe probek (32, 64, 128, ...)
           bx=[x(n-i*N+1:n),zeros(1,i*N)]; % wycinamy fragment sygnalu
           BX = fft(bx);				   % FFT 
           XH1 = BX.*H(k,   1:2*(i*N));    % w jednym przebiegu petli
           XH2 = BX.*H(k+1, 1:2*(i*N));    % liczymy dwa sploty
           i1 = n+i*N;                     % gdzie wstawic wynik?
           i2 = n+2*i*N;                   % to samo dla drugiego odcinka
           Ny = 2*i*N;                     % dlugosc odcinka sygnalu
           y7(i1+1:i1+Ny) = y7(i1+1:i1+Ny) + real(ifft(XH1));
           y7(i2+1:i2+Ny) = y7(i2+1:i2+Ny) + real(ifft(XH2));
           k=k+2;
        else
           break % jezeli liczba probek nie dzieli sie przez N,
                 % to nie dzieli sie tez przez 2*N, 4*N itd.
        end
        i=i*2;
      end
  end    
  y7=y7(1:length(y7)-Nh);
  blad7 = max(abs(y1-y7))