% Przyklad 5.6
  clear all; close all;

% Inicjowanie parametrow
  N = 256;       % liczba probek obu sygnalow
  M = 64;        % liczba przesuniec w jedna strone
  L = 1000;      % liczba prazkow funkcji wzajemnej gestosci widmowej mocy
  m = N-M: N+M;  % indeksy wspolczynnikow liczonych "szybko"

% Generowanie (synteza) sygnalow
  fx = 100; fpr = 1000; dt=1/fpr; t=0:dt:(N-1)*dt; tR=-(N-1)*dt:dt:(N-1)*dt;
  x1 = rand(1,N); x2 = randn(1,N);
% x1 = sin(2*pi*fx*t); x2=x1;
  subplot(211); plot(x1); grid; axis tight; title('Sygnaly analizowane');
  subplot(212); plot(t,x2); grid; axis tight; xlabel('czas [sek]'); pause

% Obliczenie funkcji korelacji wzajemnej sygnalow procedura Matlaba
% R1 = xcorr(x1,x2,'biased');           % tak
  R1 = conv(x1, conj(x2(end:-1:1)))/N;  % lub tak

% Obliczenia "reczne" funkcji korelacji wzajemnej bezposrednio z definicji
  for k=0:M
      R21(k+1)= sum( x1(1+k:N).*x2(1:N-k) ) / N;
      R22(k+1)= sum( x1(1:N-k).*x2(1+k:N) ) / N;
  end
  R2 = [ R22(M+1:-1:2) R21(1:M+1) ];
  subplot(211); plot(tR(m),R1(m)); grid; axis tight; title('Funkcja korelacji - Matlab');
  subplot(212); plot(tR(m),R2); grid; axis tight; title('Funkcja korelacji - "recznie"'); pause
  max(abs( R1(m)-R2)), pause
  
% Obliczenia "szybkie" 2*M+1 srodkowych wspolczynnikow funkcji korelacji wzajemnej
% z FFT
  x1 = [ x1 zeros(1,M) ];                  % dodaj M zer na koncu sygnalu
  x2 = [ x2(M+1:end) zeros(1,M) x2(1:M) ]; % dodaj M zer "wewnatrz" sygnalu
  X1 = fft(x1);                            % oblicz FFT (N+M)-punktowe
  X2 = fft(x2);                            % oblicz FFT (N+M)-punktowe
  X = X1.*conj(X2);                        % oblicz X1(k)*conj(X2(k))
  R = ifft(X);                             % oblicz odwrotne FFT (N+M)-punktowe
  R3 = real(R(1:2*M+1))/N;                 % pobierz poprawne wartosci, przeskaluj
  subplot(111); plot(tR(m),R1(m),'r',tR(m),R3,'b'); grid; axis tight;
  title('Metoda "szybka" - Matlab (red), My (blue)'); xlabel('czas [sek]'); pause
  max(abs( R1(m)-R3)), pause

% Funkcja wzajemnej gestosci widmowej mocy metoda Blackmana-Tukeya
  w = hanning(2*M+1); w=w';                      % wybierz okno widmowe, np. Hanninga
  Rw = R3 .* w;                                  % wymnoz funkcje autokorelacji z oknem
  s = [ Rw(M:2*M+1) zeros(1,L-2*M+1) Rw(1:M+1)]; % symetria dane wejsciowe dla FFT
  S = abs(fft(s));                               % transformacja Fouriera
  df = 1/(L*dt); f=0:df:(L-1)*df; k=1:L/2+1;
  subplot(111); plot(f(k),S(k),'b'); grid; title('Funkcja gestosci widmowej mocy');
  xlabel('f [Hz]'); pause
  