% Przyklad 6.3:
function przyklad_06_03()

M = 8;                                                             % Liczba kanalow.
S = 8;                     % Wspolczynnik podprobkowania. Np. probkowanie krytyczne.
N = 32;                                              % Dlugosc filtru prototypowego.
fc = 1/M + 0.0018;    % Znormalizowania czestotliwosc odciecia filtru prototypowego.
p = fir1(N - 1, fc, kaiser(N,5)); % Synteza prototypu z wykorzystaniem okna Kaisera.
% p = ones(1, M) ./ M;              % Alternatywnie: okno prostokatne jako prototyp.
hs = fb_dft_modulated_filters(p, M);          % Generacja wspolczynnikow filtrow ...
                                                % na podstawie prototypu.

fb_show_response(hs, 512);               % Prezentacja charakterystyk amplitudowych.
fb_show_prototype(p, 512, 1/M);                             % Prezentacja prototypu.

x = [1 zeros(1, 127)];                                           % Sygnal wejsciowy.
xs = fb_analysis(hs, S, x);  % Analiza podpasmowa. Sygnaly kanalow w wierszach $xs$.
ys = xs; % Brak przetwarzania kanalow, aby sprawdzic czy zespol filtrow zapewnia PR.
y = fb_synthesis(hs * S, S, ys);       % Synteza wyjsciowego sygnalu pelnopasmowego.

fb_show_io(x, real(y), 512);                % Prezentacja sygnalu oryginalnego i ...
max(abs(imag(y)))      % zrekonstruowanego. Czesc urojona wyniku powinna byc zerowa.

%===================================================================================
function h = fb_dft_modulated_filters(p, M)      % Wspolczynniki $M$-kanalowego ...
                                                 % zespolu filtrow modulowanych DFT.

N = length(p);                                   % Dlugosc filtru prototypowego $p$.
[k, n] = ndgrid(0 : (M - 1), 0 : (N - 1));               % Generacja indeksow i  ...
h = repmat(p, M, 1) .* exp(-1i * 2 * pi / M) .^ (-k .* n); % wspolczynnikow filtrow.