% Przyklad 6.5
function przyklad_06_05()

M = 4;                                      % Wspolczynnik decymacji i interpolacji.
h = fir1(31, 1 / M);                      % Wspolczynniki filtru dolnoprzepustowego.
x = sin((0 : 127) / 128 * 2 * pi * 8);                           % Sygnal wejsciowy.
v = filter_interpolator(h, M, x);                                    % Interpolacja.
v = filter([0 1], 1, v);           % Opoznienie sygnalu zinterpolowanego o 1 probke.
y = filter_decimator(h, M, v);                                          % Decymacja.
fb_show_io(x, y, 512);               % Prezentacja sygnalu przed i po przetworzeniu.

% Efektem ubocznym decymacji i interpolacji jest dodatkowe opoznienie sygnalu o ...
% liczbe probek rowna ilorazowi dlugosci filtru i wspolczynnika decymacji minus 1.

%===================================================================================
function y = filter_decimator(h, M, x) % Polifazowa realizacja filtru decymacyjnego.

% Liczba probek x sygnalu wejsciowego i liczba wspolczynnikow h filtru ...
% dolnoprzepustowego musza byc wielokrotnosciami wspolczynnika decymacji M, ...
% zas czestotliwosc odciecia filtru musi byc rowna 1/M.

e = reshape(h, M, length(h) / M);       % Pogrupowanie wspolczynnikow skladowych ...
y = 0;                    % polifazowych filtru i inicjalizacja sygnalu wyjsciowego.
for m = 1 : M,                         % Iteracja po skladowych polifazowych filtru.
    y = y + filter(e(m, :), 1, x(m : M : end));      % Filtrowanie opoznionego i ...
    % zdecymowanego sygnalu za pomoca skladowej polifazowej.
end;          % Sygnal wyjsciowy jest suma sygnalow z wyjsc skladowych polifazowych.

%===================================================================================
function y = filter_interpolator(h, M, x)         % Polifazowa realizacja filtru ...
% interpolacyjnego. Liczba wspolczynnikow h filtru dolnoprzepustowego musi byc ...
% wielokrotnoscia wspolczynnika interpolacji M, a czestotliwosc odciecia rowna 1/M

e = flipud(reshape(h, M, length(h) / M));          % Pogrupowanie wspolczynnikow ...
% skladowych polifazowych filtru.
y = zeros(1, M * length(x));   % Sygnal wyjsciowy lancucha opoznien (inicjalizacja).
for m = 1 : M,           % Iteracja po skladowych polifazowych transmitancji filtru.
    y = filter([0 1], 1, y); % Opoznienie sumy sygnalow z dotad rozpatrzonych galezi
    y(1 : M : end) = y(1 : M : end) + filter(e(m, :), 1, x);       % Filtrowanie ...
    % sygnalu wejsciowego za pomoca skladowej polifazowej filtru ...
end;     % i dodanie wyniku do sygnalu wyjsciowego po zwiekszeniu tempa probkowania.
y = M * y;                             % Skorygowanie amplitudy sygnalu wyjsciowego.