% Przyklad 6.6:
function przyklad_06_06()

T = mdctmtx(mdct_sine_window(8));         % Macierz transformacji. Np. macierz MDCT.
[M, N] = size(T);             % Rozmiar bloku wspolczynnikow i rozmiar bloku probek.
disp(T); disp(T' * T); disp(T * T')     % Prezentacja macierzy i jej ortogonalnosci.
fb_show_response(T, 512);        % Prezentacja zespolu filtrow okreslonego macierza.

input('Nacisnij ENTER by zademonstrowac przetwarzanie')
x = 1 : 0.5 : (4 * M);    x = x(:);               % Sygnal oryginalny. Niebyt dlugi.
y = zeros(size(x));                          % Sygnal zrekonstruowany (prealokacja).

figure;
for k = 0 : (length(x) / M - 2),      % Iteracja po segmentach sygnalu oryginalnego.
    idx = k * M + (1 : N);     % Indeksy probek segmentu. Jezeli N > M, to nakladanie.
    xs = T * x(idx);    % Obliczenie wspolczynnikow transformacji na podstawie probek.
    ys = xs;         % Brak przetwarzania wspolczynnikow, aby sprawdzic poprawnosc ...
    % rekonstrukcji probek. Transformacja odwrotna polaczona ...
    y(idx) = y(idx) + T' * ys;                     % z rekonstrukcja segmentu sygnalu.
    
    subplot(3, 1, 1); stem(x); grid on; xlabel('n'); ylabel('x[n]'); % Obrazowanie ...
    subplot(3, 1, 2); stem(y); grid on; xlabel('n'); ylabel('y[n]');     % postepu ...
    subplot(3, 1, 3); stem(y - x); xlabel('n'); ylabel('y[n] - x[n]'); % rekonstrukcji
    input('Nacisnij ENTER by kontynowac');
end

%===================================================================================
function T = mdctmtx(w)                 % Macierz MDCT o zadanym oknie $w$.

M = length(w) / 2;             % Ustalenie rozmiaru transformacji na podstawie okna.
[k, n] = ndgrid(0 : (M - 1), 0 : (2 * M - 1));            % Generowanie indeksow ...
T = sqrt(2 / M) .* repmat(w(:)', M, 1) ...                   % i elementow macierzy.
    .* cos((2 .* n + M + 1) .* (2 .* k + 1) .* pi ./ (4 * M));

%===================================================================================
function w = mdct_sine_window(M)    % Okno sinusoidalne do MDCT o zadanym rozmiarze.

w = sin(((0 : (2 * M - 1)) + 0.5) *  pi / 2 / M);