function [y, e] = filtrWRLS1(M,d,x,lambda,delta)
% Przyklad 7.2
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl

bx = zeros(M,1);          % inicjowanie bufora sygnalu wejsciowego x
h = zeros(M,1);           % inicjowanie wag filtra
P = delta*eye(M,M);       % inicjowanie odwrotnosci macierzy autokorelacji
                          % sygnalu x[n]: P = R^{-1}
y = []; e = [];           % wyzerowanie sygnalow wyjsciowych

for n = 1 : length(x)
   bx = [ x(n); bx(1:M-1) ];     % pobierz nowa probke do bufora
   y(n) = h' * bx;               % oblicz y[n] = sum(h .* bx)
   e(n) = d(n) - y(n);           % oblicz e[n]
   if(0) % wersja 1 - filtr RLS
      P = (P + P*bx*bx'*P/(lambda+bx'*P*bx))/lambda;  % zmodyfikuj macierz P
      h = h + P * bx * e(n);                          % modyfikacja wag filtra
   else % wersja 2 - obserwator RLS z [8], [22]
      K = P*bx/(lambda+bx'*P*bx);                     % wzmocnienie Kalmana
      h = h + K * e(n);                               % modyfikacja wag filtra
      P = (eye(M)-K*bx')*P/lambda;                    % zmodyfikuj macierz P
   end
end