function [y,e] = filtrDWF(M,h,d,x)
% Non-adaptive Direct Wiener Filter
% Based on [Orfa88]

w = zeros(1,M+1);       % bufor na x[n]

for n = 1 : length(x)
    w(1) = x(n);        % nowa probka do bufora
    y(n) = w * h.';
    e(n) = d(n) - y(n);
    w = [ 0 w(1:M) ];
end    
