function [y, e, Hest, H ] = filtrFDAF_overlap_add(M,d,x,nr,mi,alfa,delta,gamma)
% Przyklad 8.7b
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl

xx = zeros(1,2*M);      % inicjowanie bufora sygnalu wejsciowego x[n]
H = zeros(1,2*M);       % inicjowanie wag filtra
X2 = zeros(1,2*M);      % inicjowanie wartosci poprzedniego widma sygnalu x[n]
J = (-1).^(0:2*M-1);    % macierz kompensacji czasowej poprzedniego widma sygnalu x[n]
lambda = 1-alfa;        % alfa = 0.01; wspolczynniki wykorzystywane podczas
P = delta*ones(1,M);    % delta = 0.25 nakladania ograniczenia na gradient f. kosztu
y = []; e = []; Hest = [];
for k = 0 : length(x)/M-1
   x1 = x(k*M+1:k*M+M);     % pobranie kolejnego bloku probek x[n]
   xx = [ x1 zeros(1,M) ];  % dodanie zer
   X1 = fft(xx); % FFT
   X = X1 + J.*X2;          % suma widm FFT: obecnego (X1) i poprzedniego (X2)
   X2 = X1;                 % zapamietanie obecnego widma
   yy = ifft(X.*H);         % obliczenie y[n]
   y = [ y real(yy(1:M))];  % wydzielenie poprawnego bloku probek y[n] i ich zapamietanie
   e1 = d( k*M+1:k*M+M ) - y( k*M+1:k*M+M ); % obliczenie bloku probek sygnalu bledu e[n]
   e = [ e real(e1)];       % zapamietanie go
   ee = [ e1 zeros(1,M) ];  % dodanie zer
   E = fft(ee);             % FFT sygnalu bledu e[n]
   delta = ifft( conj(X) .* E); % obliczenie gradientu funkcji kosztu, przejscie do dz. czasu
   if(0)                                                  % # ograniczenie gradientu
      delta = [ delta(1:M)/((x1*x1')+gamma) zeros(1,M) ]; % # w dziedzinie czasu
   else                                                   % #
      P = lambda*P + alfa*abs(X(1:M)).^2;                 % #
      delta = [ delta(1:M)./P zeros(1,M)];                % #
   end                                                    % #
   Delta = fft(delta);        % powrot z gradientem funkcji kosztu do dz. czestotliwosci
   H = H + 2*mi*Delta;        % adaptacja wag filtra w dziedzinie czestotliwosci
   Hest = [ Hest; H( nr ) ];  % zapamietanie wybranych wag filtra
end
