function [y, e, Hest, H ] = filtrFDAF_overlap_save(M,d,x,nr,mi,alfa,delta,gamma)
% Przyklad 8.7a
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl

lambda = 1-alfa;               % wspolczynniki wykorzystywane podczas
P = delta*ones(1,M);           % nakladania ograniczenia na gradient funkcji kosztu
bx = zeros(1,2*M);             % inicjowanie bufora sygnalu wejsciowego x
H = fft( [ones(1,M)/M zeros(1,M) ] );   % inicjowanie wag filtra
y = []; e = []; Hest = [];              % inicjowanie
for k = 0 : length(x)/M-1
   x1 = x(k*M+1:k*M+M);        % pobierz kolejny blok probek x[n]
   bx = [ bx(M+1:2*M) x1 ];    % wloz je do bufora
   X = fft(bx);                % FFT
   by = real(ifft(X.*H));      % oblicz y[n]
   y = [ y by(M+1:2*M)];       % oddziel poprawny blok probek y[n]
   e1 = d( k*M+1:k*M+M ) - y( k*M+1:k*M+M ); % oblicz blok probek bledu e[n]
   e = [ e e1];                % zapamietaj jako sygnal wyjsciowy
   ee = [ zeros(1,M) e1 ];     % dodaj zera
   E = fft(ee);                % FFT
   XE = conj(X) .* E;          % iloczyn widm
   if(1) % korekta gradientu f. kosztu w czasie (z tym dokladniej, bez tego - szybciej)
         delta = ifft(XE );    % przejscie z gradientem do dziedziny czasu
         if(1) delta = [ delta(1:M) zeros(1,M)]; end                    % OK
         if(0) delta = [ delta(1:M)/((x1*x1')+gamma) zeros(1,M)]; end   % test
         if(0)
             P = lambda*P + alfa*abs(X(1:M)).^2;                        % test
             delta = [ delta(1:M)./(P) zeros(1,M)];
         end
         XE = fft(delta);
   end                        % powrot z gradientem do dziedziny czestotliwosci
   H = H + 2*mi*XE;           % adaptacja wag filtra w dziedzinie czestotliwosci
   Hest = [ Hest; H( nr ) ];  % zapamietanie wybranych wag filtra
end