function [y,e,Hest,H] = filtrFDAF_overlap_save_part(Nh,M,d,x,nr,mi,alfa,delta,gamma)
% Przyklad 8.7c
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl

Lb = length(x)/M;          % liczba sekcji (blokow) probek wejsciowych
Lh = Nh/M;                 % liczba sekcji (blokow) wag filtra
lambda = 1-alfa;           % alfa = 0.01; % wspolczynniki wykorzystywane podczas
P = delta*ones(1,M);       % delta = 0.25 % ogranicz. gradientu funkcji kosztu
for k=1:Lh
   H(k,1:2*M) = fft( [ones(1,M)/M zeros(1,M)] ); % inicjowanie macierzy H wag filtr
end
y = []; e = []; Hest = [];         % inicjowanie
bx = zeros(1,2*M);                 % inicjowanie bufora bx na probki x[n]
X = zeros(Lh,2*M);                 % inicjowanie macierzy widm X
for k = 0 : Lb-1
   x1 = x(k*M+1:k*M+M);            % pobranie kolejnej sekcji probek wejsciowych x[n]
   bx = [ bx(M+1:2*M) x1 ];        % zmodyfikowanie zawartosci bufora tych probek
   X = [ fft(bx); X(1:Lh-1,:) ];   % FFT bufora, aktualizacja macierzy widm sekcji sygnalu x[n]
   XH = X.*H;                      % filtracja blokowa sygnalu x[n] w dz. czestotliwosci
   by = real(ifft(sum(XH)));       % zlozenie wynikow filtracji (sum), powrot do dz. czasu
   y = [ y by(M+1:2*M) ];          % zapisanie sygnalu wyjsciowego y[n]
   e1 = d( k*M+1 :k*M+M ) - y( k*M+1 : k*M+M );  % obliczenie probek bledu e[n]
   e = [ e real(e1)];                            % zapamietanie ich
   ee = [ zeros(1,M) e1 ];         % utworzenie wektora probek bledu e[n]
   E = fft(ee);                    % przejscie do dziedziny czestotliwosci
   for k=1:Lh
      XE(k,:) = conj(X(k,:)) .* E; % obliczenie gradientu funkcji kosztu w dz. czestotliwosci
   end
   if(1) % opcjonalne ograniczenie gradientu funkcji kosztu
      XE = XE.';                   % transpozycja bez sprzezenia
      delta = ifft(XE );           % przejscie z gradientem do dziedziny czestotliwosci
      if(1) delta = [ delta(1:M,:); zeros(M,Lh)]; end                         % OK
      if(0) delta = [ delta(1:M,:)/((x1*x1')+gamma); zeros(M,Lh)]; end        % test
      if(0) P = lambda*P + alfa*abs(X(1:M)).^2; delta = [ delta(1:M,:)./(P);  % test
      zeros(M,Lh)]; end 
      XE = fft(delta);             % powrot z gradientem do dziedziny czasu
      XE = XE.';                   % transpozycja bez sprzezenia
   end
   H = H + 2*mi*XE;                % adaptacja wag filtra w dziedzinie czestotliwosci
   Hest = [ Hest; H( nr ) ];       % zapamietanie wybranych wag filtra
end