function [y] = filtrGLLPF(M,x,lambda,beta)
% Przyklad 8.5 na podstawie [11]
% Adaptacyjny gradientowy kratowy liniowy predyktor.
% (Gradient Lattice Linear Prediction Filter)
% Rys. 8.7b tylko z adaptacja wag gamma filtra
% Autor implementacji w Matlabie: Tomasz Zielinski, tzielin@agh.edu

w = 0.000001*randn(1,M+1); % wektor roboczy, stany wewnetrzne kazdej sekcji
gamma = w; da = w;
for n = 1 : length(x)      % dla kolejnych probek sygnalu x[n]
    ea(1) = x(n);          % wejscie do pierwszej sekcji filtra
    eb(1) = x(n);          % wejscie do pierwszej sekcji filtra
    for k = 2:M+1          % kolejne sekcje filtra
       ea(k) = ea(k-1) - gamma(k)*w(k);                             % rownanie (8.2)
       eb(k) = - gamma(k)*ea(k-1) + w(k);                           % czyli "motylek"
       da(k) = lambda*da(k) + ea(k-1)*ea(k-1) + w(k)*w(k);          % nowe d[k], (8.95)(8.96)
       gamma(k) = gamma(k) + beta*(ea(k)*w(k)+eb(k)*ea(k-1))/da(k); % nowe gamma[k], (8.97)
       w(k) = eb(k-1);     % aktualizacja stanu wewnetrznego k-tej sekcji filtra kratowego
    end
    y(n) = ea(k);          % sygnal wyjsciowy y[n]
end