function [y, ghist, gamma ] = filtrGLLPF_rys(M,x,nr,lambda,beta)
% Adaptacyjny gradientowy filtr kratowy typu FIR (Gradient Lattice Linear Prediction Filter)
% Rys. 8.7b tylko z adaptacja wag filtra
% Na podstawie [Orfa88]

ghist = [];
% w = zeros(1,M+1);           
w = 0.000001*randn(1,M+1);  % stany wewnetrzne kazdej sekcji
gamma = w;   da = w;

for n = 1 : length(x)       % dla kolejnych probek sygnalu x[n]
    ea(1) = x(n);           % wejscie do pierwszej sekcji filtra
    eb(1) = x(n);           % wejscie do pierwszej sekcji filtra
    for k = 2:M+1           % kolejne sekcje filtra
        ea(k) = ea(k-1) - gamma(k)*w(k);      % rownanie (8.2), czyli ,,motylek"
        eb(k) = - gamma(k)*ea(k-1) + w(k) ;   % 

        da(k) = lambda*da(k) + ea(k-1)*ea(k-1) + w(k)*w(k);            % nowe d[k], (8.95)(8.96)
        gamma(k) = gamma(k) + beta*(ea(k)*w(k)+eb(k)*ea(k-1))/da(k);   % nowe gamma[k], (8.97)

        w(k) = eb(k-1);     % aktualizacja stanu wewnetrznego k-tej sekcji filtra kratowego)
    end
    y(n) = ea(k);                       % sygnal wyjsciowy y[n])
    ghist = [ ghist; gamma( nr+1 ) ];   % historia przestrajania wag
end
gamma = gamma(2:M+1);
