function [y,e] = filtrLWF(M,g,gamma,d,x)
% Przyklad 8.4d
% Nieadaptacyjny kratowy filtr Wienera (Lattice Wiener Filter), patrz rys. 8.7b
% Na podstawie [11]
% Autor implementacji w Matlabie: Tomasz Zielinski, tzielin@agh.edu.pl

w = 0.000001*randn(1,M+1);       % wektor roboczy, stany wewnetrzne kazdej sekcji
for n = 1 : length(x)
   ea(1) = x(n);                 % wejscie do pierwszej sekcji filtra a priori
   eb(1) = x(n);                 % j.w.
   y(n) = g(1)*eb(1);            % estymata y[n] bazujaca na sekcji 1
   e(n) = d(n) - y(n);           % estymata e[n] bazujaca na sekcji 1
   for k = 2:M+1                 % kolejne k-te sekcje filtra kratowego (8.2), rys.8.7b
      ea(k) = ea(k-1) - gamma(k)*w(k);    % blad ek+[n]
      eb(k) = w(k) - gamma(k)*ea(k-1);    % blad ek-[n]
      w(k) = eb(k-1);            % stan wewnetrzny k-tej sekcji
      y(n) = y(n) + g(k)*eb(k);  % estymata a posteriori xest[n] rzedu "k", rown. (8.84)
      e(n) = e(n) - g(k)*eb(k);  % blad a posteriori e[n] rzedu "k", rownanie (8.86)
   end
end