function [y, e, hest, h ] = filtrWLS(M,d,x,nr,lambda,ifig)
bx = zeros(1,M);		%   inicjalizacja bufora sygnalu wejsciowego x
h  = zeros(1,M);		%   inicjalizacja wag filtra
R = zeros(M,M);         %   inicjalizacja macierzy autokorelacji sygnalu x[n]
y = [];   e = [];		%   wyzerowanie sygnalow wyjsciowych
hest = [];              % historia przestrajania wybranych wag filtra 
for n = 1 : length(x)
    bx = [ x(n) bx(1:M-1) ];		%   pobierz nowa probke do bufora
	y(n) = h * bx';					%   oblicz y[n] = sum( x .* bx)
	e(n) = d(n) - y(n);				%   oblicz e[n]
	R = lambda*R + bx'*bx;          %
    dh = pinv(R)* e(n) * bx';       %
	h = h + dh';            		%  modyfikacja wag
    hest = [ hest; h( nr ) ];       % zapisz wartosci wybranych wag filtra
    
    if(ifig==1)  % rysunki w petli, na zyczenie
       n
       subplot(211); stem(h); title('h[n]'); grid;
       subplot(212); [H, w ] = freqz(h,1,100); stem( w, abs(H)); title('H(w)'); grid; pause
    end   
end
