function [L,E,g,h] = firw(M,rdx,rxx)
% Przyklad 8.4c
% Projektowanie wspolczynnikow filtra FIR Wienera na podstawie [11]
% Autor implementacji w Matlabie: Tomasz Zielinski, tzielin@agh.edu.pl

[L,E] = lev(M,rxx);                            % algorytm Levinsona
for k=1:M+1
    g(k) = sum( L(k,1:k) .* rdx(1:k) )/E(k);   % g=Dinv*L*rdx, rownanie (8.83)
end
for k=1:M+1
    h(k) = sum( (L(k:M+1,k).') .* g(k:M+1) );   % h=L'*g, rownanie (8.83)
end