function [L,E] = lev(M,rxx)
% Przyklad 8.4b
% Obliczanie wspolczynnikow filtrow predykcji liniowej rzedu od 1 do M
% na podstawie wektora rxx autokorelacji sygnalu x[n]
% metoda Durbina-Levinsona - inny zapis niz w tabl. 8.2, taki jak w [11]
% Autor implementacji w Matlabie: Tomasz Zielinski, tzielin@agh.edu.pl

L(1,1)=1; L(2,2)=1; L(2,1)=-rxx(2)/rxx(1);
E(1)=rxx(1); E(2)=E(1)*(1-L(2,1)^2);
for k = 3:M+1
   delta = sum( rxx(2:k) .* L(k-1,1:k-1) );        % rownanie (8.58b)
   gamma = delta/E(k-1);                           % rownanie (8.68)
   L(k,1) = - gamma;
   for i = 2:k-1
      L(k,i) = L(k-1,i-1) - gamma*L(k-1,k-1-i+1);  % rownanie (8.69)
   end
   L(k,k)=1;
   E(k)=E(k-1)*(1-gamma^2);                        % rownanie (8.70)
end