% Przyklad 8.3
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl

  clear all; clf;
  
% Podaj wspolczynniki transmitancji H(z)=B(z)/A(z) filtra (UWAGA! a(1)=1, M<=N)
  b = [ 1 3 3 1 ]; a = [ 1 -0.9 0.64 -0.576 ];
  P=length(b); N=length(a);
  aa=a(2:N); M=N-1; % odrzucamy pierwszy element rowny 1
  
% Oblicz wspolczynniki "odbicia" gamma(i) filtra kratowego - tabela 8.1
% rownania (8.21)(8.22)
  aij(M,1:M)=aa(1:M);
  for i=M:-1:1
      gamma(i)=-aij(i,i);
      for j=1:i-1
          aij(i-1,j) = (aij(i,j)+gamma(i)*aij(i,i-j))/(1-gamma(i)^2);
      end
  end
  gamma, pause
  
% Oblicz wspolczynniki c(i) filtra kratowego - rownanie (8.40)
  for k = P:-1:1
     s=0; for(j=k+1:P) s = s + c(j)*aij(j-1,j-k); end
     c(k) = b(k) - s;
  end
  c, pause

% Sygnal filtrowany
  Nx=100; n=0:Nx-1; x=sin(2*pi*n/12+pi/4);

% Filtracja "kratowa"
% "zera i bieguny" (rys. 8.4e i 8.6b) : H3(z)= [ 1 3 3 1 ] / [1 -0.9 0.64 -0.576 ]
  y3 = filtrK_ZB( x, gamma, c);
% Rysunki
  plot(y3); title('Sygnal wyjsciowy - filtr: zera i bieguny'); pause
% Porownanie ze zwykla filtracja
  y3z = filter(b,a,x);
  plot(y3-y3z); title('Roznica z filter(b,a,x)'); pause

%-----------------------------------------------------------------------------------
% function y = filtrK_ZB(x,gamma,c)
% Filtr kratowy - zera i bieguny
% N=length(x);
% M=length(gamma);
% eb(1:M) = zeros(1,M);
% for n = 1 : N
%    ea(M+1) = x(n); % kolejna probka
%    for k = M : -1 : 1 % kolejne sekcje filtra (8.27)
%       ea(k) = ea(k+1) + gamma(k)*eb(k);
%       eb(k+1) = eb(k) - gamma(k)*ea(k);
%    end
%    eb = [ ea(1) eb(2:M+1) ];
%    y(n) = sum( c.*eb(1:M+1) );
% end
