
% ----------------------------------------------
% Przyklad 8.1 + 8.2 + 8.3: Filtry kratowe razem
% Autor: Tomasz Zielinski, tzielin@agh.edu.pl
% ----------------------------------------------

  clear all; clf;

% Podaj wspolczynniki transmitancji H(z)=B(z)/A(z) filtra (UWAGA! a(1)=1, M<=N)
  b = [ 1 3 3 1 ]; a = [ 1 -0.9 0.64 -0.576 ]
  M=length(b); N=length(a);
  aa=a(2:N); P=N-1;   % odrzucamy pierwszy element rowny 1 
  
% Oblicz wspolczynniki ,,odbicia" gamma(i) filtra kratowego - tabela 8.1,(8.21)(8.22)
  aij(P,1:P)=aa(1:P);
  for i=P:-1:1
      gamma(i)=-aij(i,i)
      for j=1:i-1
         aij(i-1,j)=(aij(i,j)+gamma(i)*aij(i,i-j))/(1-gamma(i)^2);
      end
    % pause
   end
   gamma, pause

% Odtworz w celach testowych wspolczynniki {a} na podstawie {gamma} - tabela 8.1
  aa = zeros(P,P);
  aa(1,1) = -gamma(1);
  for i=2:P  
      aa(i,i) = -gamma(i);
      for j=1:i-1
          aa(i,j) = aa(i-1,j) - gamma(i)*aa(i-1,i-j);
      end
  end
  aa =  [ 1 aa(P,:) ], pause
     
% Oblicz wspolczynniki c(i) filtra kratowego - rownanie (8.40)
   for k = M:-1:1
      s=0; for(j=k+1:M) s = s + c(j)*aij(j-1,j-k); end   
      c(k) = b(k) - s;
   end   
   c, pause
   
% Sygnal filtrowany
  Nx=100; n=0:Nx-1; x=sin(2*pi*n/12+pi/4);  

% Filtracja ,,kratowa"
% ,,tylko zera" (rys. 8.X i 8.Y): H1(z)=A(z)=[ 1 -0.9 0.64 -0.576 ];
  y1 = filtrK_Z( x, gamma); 
% ,,tylko bieguny" (rys. 8.X i 8.Y):  H2(z)= 1 / [1 -0.9 0.64 -0.576 ]
  y2 = filtrK_B( x, gamma);
% ,,zera i beguny" (rys. 8.X i 8.Y) : H3(z)= [ 1 3 3 1 ] / [1 -0.9 0.64 -0.576 ]
  y3 = filtrK_ZB( x, gamma, c);
  
% Rysunki
  plot(y1); title('Sygnal wyjsciowy - filtr: tylko zera'); pause
  plot(y2); title('Sygnal wyjsciowy - filtr: tylko bieguny'); pause
  plot(y3); title('Sygnal wyjsciowy - filtr: zera i bieguny'); pause

% Porownanie ze zwykla filtracja
  y1z = filter(a,1,x);
  y2z = filter(1,a,x);
  y3z = filter(b,a,x);
  
  subplot(311); plot(y1-y1z); title('Roznica z filter(a,1,x)');
  subplot(312); plot(y2-y2z); title('Roznica z filter(1,a,x)');
  subplot(313); plot(y3-y3z); title('Roznica z filter(b,a,x)'); pause
