% Przyklad 10.3:
% m-plik: przyklad_10_3.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 10: Sterowanie dynamika sygnalu.
% Autorzy rozdzialu: Roman Rumian, Wojciech Polchlopek.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2014 r.

clc; clear; close all;

fpr=48000;                      % czestotliwosc probkowania, w [Hz];
dt=1/fpr;                       % odstep miedzy kolejnymi probkami na osi czasu;
N=2^12;                         % liczba probek;
n=0:N-1;                        % numery probek sygnalu;

fo=1000;                        % czestotliwosc sygnalu, w [Hz];
fa=fo/100;                      % czestotliwosc modulacji amplitudy, w [Hz];
ax=abs(cos(2*pi*n*fa/fpr));     % zmienna w czasie amplituda sygnalu;
x0=sin(2*pi*n*fo/fpr);          % sygnal o stalej amplitudzie;
x=x0.*ax;                       % generowanie sygnalu wejsciowego;

% Projektujemy dyskretny filtr Hilberta (FIR):
        M=200;          m=-M:M;
        h=sinc(m/2).^2.*(pi*m/2);
        w=blackman(2*M+1)';        
        h=h.*w;                 % korekcja z uzyciem okna;

% Powracamy do obliczen:        
xH=conv(h,x);                   % wynik filtracji filtrem Hilberta;
xH=xH(M+1:M+1+N-1);             % kompensacja opoznienia;

xMAX=sqrt(x.^2+xH.^2);          % wyznaczenie obwiedni;

y=x0.*xMAX;                     % weryfikacja efektu;

t=n*dt;                         % punkty na osi czasu, wyrazone w [s];

    figure(1);
        plot(t,x,'bo-','markersize',4);  grid on; hold on;
        plot(t,xMAX,'k.-');
        plot(t,y,'r.-');
            title('Efekt dzialania algorytmu AGC z wykorzystaniem filtru Hilberta');
            legend('sygnal wejsciowy','obwiednia x_M_A_X','sygnal odtworzony z obwiedni',1);
            xlabel('t [s]');
            xlim([t(1),t(end)]);            
            
% KONIEC PRZYKLADU 10.3.