function y = ss_nr(x)

x = x(:);     % wymuszenie notacji kolumnowej
N = 256;      % dlugosc ramki (w probkach), musi byc parzysta!
K = 128;      % nakladanie sie ramek (l. probek)
W = hann(nw); % funkcja okna analizy
a = 1;        % typ metody: 1 - MSS, 2 - PSS
lmbd = 3;     % wspolczynnik kompensacji
N2 = N/2+1; 
y = zeros(size(x)); 
Da = zeros(N2,1); 
Xa = zeros(N2,1);

for n = 1:N-K:length(x)-N,
    % analiza
    sel = n:n+N-1;
    X = fft(x(sel).*W);
    Xa = abs(X(1:N2)).^a;
    % estymacja szumu w oparciu o 10 poczatkowych ramek
    if n < 10, Da = ((n-1)*Da + Xa)/n; end;
    % wazenie widmowe
    Gss = max(1 - lmbd*(Da./(Xa+eps)), 0).^(1/a);
    Y = X(1:N2) .* Gss;
    % synteza
    Y(N2+1:N) = flipud(conj(Y(2:N2-1)));   % odtworzenie symetrii DFT
    y(sel) = y(sel)+real(ifft(Y))./max(W); % nakladanie z dodawaniem
end;

subplot(2,1,1); 
    plot(x);
subplot(2,1,2); 
    plot(y);