function y = tdc_nr(x)

N = 32;          % wymiar przestrzeni sygnalu
M = 256;         % dlugosc ramki (l. probek)
K = 128;         % nakladanie sie ramek (l. probek)
Lmbd_thr = 3e-3; % parametr progowy dla wartosci wlasnych
mu = 5;          % mnoznik Lagrange'a
x = x(:);
y = zeros(size(x));
W = bartlett(M);

% estymacja wariancji szumu na podstawie 1000 pierwszych probek sygnalu x
sigma2_d = var(x(1:1000));

for n = 1:M-K:length(x)-N, % przetwarzanie w ramkach
    
    sel = n:n+M-1;
    Xt = buffer(x(sel),N,N-1,'nodelay'); % mac. trajektorii
    Cx = (Xt*Xt')./size(Xt,2);           % empiryczna mac. kowariancji
    Cy = Cx - sigma2_d*eye(N);           % est. mac. kowariancji mowy
    [Uy, Lmbd_y] = eig(Cy);              % est. mac. KLT i war. wlasnych
    Lmbd_y = diag(Lmbd_y);
    I = find(Lmbd_y > Lmbd_thr);         % progowanie war. wlasnych
    
    g_tdc = zeros(N,1);
    g_tdc(I) = Lmbd_y(I)./(Lmbd_y(I) + mu*sigma2_d); % wsp. filtru TDC
    Yt = Uy * (diag(g_tdc) * (Uy' * Xt));            % filtracja
    
    % usrednianie diagonalne (synteza sygnalu)
    Y = zeros(M,1);
    w = zeros(M,1); 
    i = 1:N;
    for m = 1:size(Yt,2),
        Y(i) = Y(i) + Yt(:,m);
        w(i) = w(i) + 1;
        i = i+1;
    end;
    
    % nakladanie (usrednianie) ramek z dodawaniem
    y(sel) = y(sel) + (Y./w).*W; 
end;

subplot(2,1,1); 
    plot(x);
subplot(2,1,2); 
    plot(y);