% Implementacja metody DTW w programie MATLAB, przyklad na str. 522

function [xxx nr ] = dtw( Cx, Cwzr, Nwzr)
% rozpoznawanie slowa poprzez porownanie macierzy jego wsp. cepstralnych Cx z wzorcami Cwzr metoda DTW 

[ Ns, Np ] = size(Cx);             % liczba wektorow wspolczynnikow cepstralnych slowa, ich dlugosc

for numer = 1 : length(Nwzr)       % porownaj Cx z Cwzr wszystkich wzorcow

   %  Obliczenie odleglosci d(ns, nw) pomiedzy poszczegolnymi cepstrami sygnalu (ns) i sprawdzanego wzorca (nw)
    Nw = Nwzr( numer );                          % liczba wektorow wsp. cepstralnych wzorca
    Q = round( 0.2 * max(Ns,Nw) );               % wspolczynnik szerokosci sciezki
    d = Inf*ones(Ns,Nw); tg=(Nw-Q)/(Ns-Q);       % inicjalizacja macierzy odleglosci, tangens kata
    for ns = 1:Ns                                % dla kazdego cepstrum rozpoznawanego slowa
        down(ns) = max( 1, floor(tg*ns-Q*tg));   % ograniczenie dolne
        up(ns)   = min( Nw, ceil(tg*ns+Q));      % ograniczenie gorne
        for nw = down(ns) : up(ns)               % dla kazdego cepstrum wzorca
            d(ns,nw) = sqrt( sum((Cx(ns, 1:Np) - Cwzr(nw, 1:Np, numer)).^2 )); % odleglosc
        end
    end
    
  % Obliczenie odleglosci zakumulowanej g()
    g = d;                                             % inicjalizacja
    for ns = 2:Ns, g(ns,1) = g(ns-1,1) + d(ns,1); end  % zakumuluj pierwsza kolumne
    for nw = 2:Nw, g(1,nw) = g(1,nw-1) + d(1,nw); end  % zakumuluj pierwszy wiersz
    for ns = 2:Ns                                % akumuluj w pionie (slowo)
        for nw = max( down(ns), 2 ) : up(ns)     % akumuluj w poziomie (wzorzec)
            dd = d(ns,nw);                       % odleglosc cepstrum "ns" slowa od wzorca "nw"
            temp(1) = g(ns-1,nw) + dd;           % ruch do gory
            temp(2) = g(ns-1,nw-1) + 2*dd;       % ruch po przekatnej (do gory w prawo)
            temp(3) = g(ns,nw-1) + dd;           % ruch w prawo
            g(ns,nw) = min( temp );              % wybierz minimalna wartosc zakumulowana
        end
    end
    glob(numer) = g(Ns,Nw)/sqrt(Ns^2+Nw^2);       % wartosc zakumulowana "najkrotszej" sciezki
end
[ xxx nr ] = min( glob );                        % numer wzorca o najmniejszej wartosci zakumulowanej
