% Przyklad 14.04
function [] = ekstrahuj_melcepstrum(files_list, experim_dir)

    % ----------------------- Parametry ekstrakcji -------------------------- %

    fpr = 16000;                % czestotliwosc probkowania
    Nc  = 12;                   % liczba wyznaczanych wspolczynnikow 
                                % melcepstralnych
    twind = 30;                 % dlugosc okna obserwacji (ramki danych) w 
                                % milisekundach
    tstep = 15;                 % przesuniecie pomiedzy kolejnymi 
                                % polozeniami okna w milisekundach
    Mlen  = (twind*0.001)*fpr;  % liczba probek okna (ramki danych)
    Mstep = (tstep*0.001)*fpr;  % liczba probek przesuniecia pomiedzy 
                                % kolejnymi polozeniami okna
 
    W  = '0'; % dodanie wspolczynnika zerowego w funkcji melcepstrum
    P  = 30;  % liczba filtrow w banku filtrow
    FL = 0;   % dolny zakres czestotliwosci w banku filtrow 0.0*fpr
    FH = 0.5; % gorny zakres czestotliwosci w banku filtrow 0.5*fpr
    
    normalise_variances = true; %czy normalizowac wariancje? Srednie sa normalizowane domyslnie.
    
    [classes, paths, num_files, num_classes] = load_list(files_list);

    melfeats = cell(num_classes, 36);
    counter = zeros(num_classes, 1);
    
    for j=1:num_files
        [wz,FS,WMODE] = wavread(paths{j});                  % odczytywanie WAV-a
        feats = melcepstrum(wz,FS,W,Nc,P,Mlen,Mstep,FL,FH); % oblicz macierz parametrow MFCC
        counter(class2idx(classes(j))) = counter(class2idx(classes(j))) + 1;
        [num_frames, D] = size(feats);
        melfeats(class2idx(classes(j)), counter(class2idx(classes(j)))) = mat2cell(feats, num_frames, D);                                         
    end
    
    % normalizuj cechy w taki sposob aby mialy srednia rowna zero 
    % i wariancje rowna 1 (jezeli normalise_variances = true)cq
    fprintf(1, '---- Normalizowanie srednich i wariancji. \n');
    [gmean, gstdev] = compute_cmvn_stats(melfeats);
    melfeats = apply_cmvn(melfeats, gmean, gstdev, normalise_variances);
    
    [pathstr, name, ext] = fileparts(files_list);
    save_filename = strcat(experim_dir, '/', name, '_melcepstrum.mat' );
    if is_octave()
        save('-mat', save_filename, 'melfeats')
    else
        save(save_filename, 'melfeats', '-mat')
    end
        
  

