function [rfeats] = apply_cmvn(cfeats, gmean, gstdev, normalise_variances)
    [C, R] = size(cfeats);
    rfeats = cell(C, R);
    for c=1:C
        for r=1:R
            feats = cell2mat(cfeats(c, r));
            if is_empty_cell(feats) continue; end
            [T, D] = size(feats);
            feats = feats - repmat(gmean, T, 1);
            if (normalise_variances)
                feats = feats ./ repmat(gstdev, T, 1); 
            end  
            rfeats(c, r) = mat2cell(feats, T, D);
      end
  end
end

