function [gmean, gstdev] = compute_cmvn_stats(cfeats)
   
  [C R] = size(cfeats);
  [T, D] = size(cell2mat(cfeats(1,1)));
  
  var_floor = 0.01; %jezeli wariancja danych jest mniejsza od 'var_floor', uzyj var_floor
  feats_num = 0;
  mean_acc = zeros(1, D);
  sqr_acc = zeros(1, D);
  
  for c=1:C
     for r=1:R
        feats = cell2mat(cfeats(c,r));
        [frames_num, xxx] = size(feats);
        feats_num = feats_num + frames_num;
        mean_acc = mean_acc + sum(feats);
        sqr_acc = sqr_acc + sum(feats.^2);
      end
  end

  gmean = mean_acc./feats_num;
  gstdev = sqrt(sqr_acc./feats_num - gmean.^2);

  floor_idx = find(gstdev<=var_floor);  
  gstdev(floor_idx) = var_floor;

end

