function hmms = hmm_create(num_hmms, num_states, num_mixtures, D)
    % Funkcja tworzy zbior 'num_hmms' modeli HMM, z ktorych kazdy ma
    % num_states stanow opisanych przez
    % num_mixtures komponentow Gaussa o wymiarze D
    for i=1:num_hmms
        hmms(i).id = i;
        hmms(i).mu = zeros(num_states, num_mixtures, D);          % poczatkowe wektory srednich
        hmms(i).sigma = make_sigmas(num_states, num_mixtures, D); % poczatkowe macierze kowariancji
        hmms(i).c = ones(1, num_mixtures)/num_mixtures;           % poczatkowe wagi poszczegolnych komponentow w stanie
        hmms(i).A = make_transmat(num_states, 0.6);               % poczatkowe macierze przejsc
    end
end
