% this piece of code is based on Kevin Murphy's mk_stochastic function from KPMTools
% and makes the vector or 2D matrix row-wise stochastic, i.e. vector will sum to one or each row in a matrix will sum to one
function [T, Z] = normalise_matrix(T)
    if (ndims(T)==2) && (size(T,1)==1 | size(T,2)==1)
        [T, Z] = normalise(T);
    else if ndims(T)==2
        Z = sum(T,2); 
        S = Z + (Z==0);
        norm = repmat(S, 1, size(T,2));
        T = T ./ norm;
    else
       error('Only up to 2 dimensions supported for stochastic matrix normalisation');
    end
end
