function y=rdct(x,n,a,b)
%RDCT  oblicza DCT z macierzy (wektora) liczb rzeczywistych x   
% wektor z danymi x jest przycinany lub uzupelniany zerami do dlugosci n, o
% ile n jest wyspecyfikowane.
% Ponizszy program jest rownowazny mnozeniu macierzy (wektora) z danymi x
% przez macierz: 
%   rdct(eye(n)) = diag([sqrt(2)*B/A repmat(2/A,1,n-1)]) * cos((0:n-1)'*(0.5:n)*pi/n)
% Domyslne wartosci czynnikow skalujacych wynosza: a=sqrt(2n) oraz b=1 

fl=size(x,1)==1;
if fl x=x(:); end
[m,k]=size(x);
if nargin<2 n=m;
end
if nargin<4 b=1;  
    if nargin<3 a=sqrt(2*n);
    end
    end
if n>m x=[x; zeros(n-m,k)];
elseif n<m x(n+1:m,:)=[];
end

x=[x(1:2:n,:); x(2*fix(n/2):-2:2,:)];
z=[sqrt(2) 2*exp((-0.5i*pi/n)*(1:n-1))].';
y=real(fft(x).*z(:,ones(1,k)))/a;
y(1,:)=y(1,:)*b;
if fl y=y.'; end
