function y=rfft(x,n,d)
%RFFT oblicza DFT z macierzy (wektora) liczb rzeczywistych x
% wektor z danymi x jest przycinany lub uzupelniany zerami do dlugosci n, o ile n jest wyspecyfikowane 
%   dla n parzystego jest zwracanych (n+2)/2 wartosci DFT, gdzie pierwsza i ostatnia wartosc jest liczba rzeczywista
%   dla n nieparzystego jest zwracanych (n+1)/2 wartosci DFT, gdzie pierwsza i ostatnia wartosc jest liczba rzeczywista
% w obydwu przypadkach liczba zwracanych wartosci jest obliczana za pomoca komendy fix(1+n/2) 
% d - wymiar wzdluz ktorego dokonywana jest DFT, gdy d=1, DFT jest wykonywane po kolumnach macierzy (wektora) x, a gdy d=2, to jest wykonywane po wierszach po is the dimension along which to do the DFT

s=size(x);
if prod(s)==1
    y=x
else
    if nargin <3 || isempty(d)
        d=find(s>1,1);
        if nargin<2
            n=s(d);
        end
    end
    if isempty(n) 
        n=s(d);
    end
    y=fft(x,n,d);
    y=reshape(y,prod(s(1:d-1)),n,prod(s(d+1:end))); 
    s(d)=fix(1+n/2);
    y(:,s(d)+1:end,:)=[];
    y=reshape(y,s);
end
