% przyklad 16.1:
function [y_re,y_im] = Sprdng(fc,x_re,x_im)
% Rozpraszanie czestotliwosciowe dla modelu A
%
% [x_re,x_im] = Sprdng(x_re,x_im)
% f0 - poziomy wektor czestotliwosci srodkowych podpasm
% x_re, x_im - probki podpasm w kolejnych ramkach (kolumnami)
N = size(x_re,1);                                              % Liczba ramek
dist = 0.1.^((z(fc(40))-z(fc(1)))/(39*20));                    % Odleglosc w Barkach pomiedzy pasmami
a = exp(-32/(48000*0.1));                                      % Wspolczynnik filtru wygladzajacego
b = 1-a;
Ex = x_re.^2 + x_im.^2;                                        % Energia chwilowa

% Gorne zbocze funkcji poszerzajacej
Su = max(4,(24+230./repmat(f0,N,1)-2*log10(Ex)));
Cu = filter(a,[1, -b],dist.^Su);                               % Wygladzenie w czasie

% Poszerzanie w kierunku wyzszych czestotliwosci
for n = 1:N                                                    % Operacja osobna dla kazdej ramki
    A_re(n,:) = conv(Cu(n,:),x_re(n,:));
    A_im(n,:) = conv(Cu(n,:),x_im(n,:));
end

% Usuniecie zbednej czesci splotu i odwrocenie
A_re = fliplr(A_re(:,1:40));
A_im = fliplr(A_im(:,1:40));

% Poszerzanie w kierunku nizszych czestotliwosci
Cd = dist^31;                                                  % Dolne zbocze funkcji poszerzajacej
for n = 1:N                                                    % Operacja osobna dla kazdej ramki
    B_re(n,:) = conv(Cd(n,:),A_re(n,:));
    B_im(n,:) = conv(Cd(n,:),A_im(n,:));
end

% Ponowne usuniecie zbednej czesci splotu i odwrocenie
y_re = fliplr(B_re(:,1:40));
y_im = fliplr(B_im(:,1:40));
end
 
function bark = z(f)

% Konwersja czestotliwosci na Barki
bark = 7*asin(f/650);
