function f=ramkowanie(x,win,inc)
%RAMKOWANIE dzieli sygnal na pokrywajace sie ramki. Ramki sa zapisywane w rzedach macierzy f.
%
% Argumenty wejsciowe:      x       sygnal wejsciowy
%                           win     dyskretne okno czasowe np. okno Hamminga
%                           inc     przesuniecie miedzy poczatkami ramek (okien) w probkach
%
% Argumenty wyjsciowe:      f       macierz z sygnalem podzielonym na ramki w rzedach sa zapisywane famki sygnalu
%                                   wymnozone przez funkcje okna, a indeks kolumny jest indeksem czasu

nx=length(x(:));    % dlugosc sygnalu w probkach
lw =length(win);    % dlugosc okna (ramki) w probkach
w = win(:)';
nli=nx-lw+inc;
nf = fix((nli)/inc);    % liczba ramek w sygnale
na=nli-inc*nf;
fn=zeros(nf,lw);
indf= inc*(0:(nf-1)).'; % wektor z poczatkami ramek
inds = (1:lw);          % wektor z indeksami probek w ramce
fn(:) = x(indf(:,ones(1,lw))+inds(ones(nf,1),:)); % podzial sygnalu na ramki
f = fn .* w(ones(nf,1),:); % wymnazanie ramek sygnalu przez funkcje okna

% obejrzyj pierwsze 10 ramek sygnalu
if nargout<1
   for i=1:10
    subplot(3,1,1); 
    plot(fn(i,:)); xlabel('Indeks ramki'); title('Sygnal w ramce');
    subplot(3,1,2)
    plot(w); xlabel('Indeks ramki'); title('Funkcja okna');
    subplot(3,1,3)
    plot(f(i,:)); xlabel('Indeks ramki'); title('Zokienkowany sygnal w ramce');
    pause
   end
end