% Przyklad 14.4
% Rozpoznawanie izolowanych cyfr od 0 do 9 za pomoca DTW

function [] = rozpoznawanie_DTW_melcepstrum(experiment_name)

    load(strcat(experiment_name, '/uczacy_melcepstrum.mat'));
    train_feats = melfeats;
    load(strcat(experiment_name, '/testowy_melcepstrum.mat'));
    test_feats = melfeats;
    
    [num_classes, num_examples] = size(train_feats);
    [num_classes_test, num_examples_test] = size(test_feats);
    confusion_matrix = zeros(num_classes, num_classes); % macierz pomylek

    if num_classes_test ~= num_classes
        error('Zbior testowy zawiera przyklady opisujace niewidzane na etapie trenowania klasy')
    end
    
    tic();
    
    % znajdz najmniejsza odleglosc DTW pomiedzy wszystkimi przykladami trenujacymi i testowymi.
    % Klasa przykladu testowego jest zdefiniowana przez klase do ktorej nalezy przyklad uczacy
    % majacy najmniejsza odleglosc DTW (bedacy najbardziej podobny)
    for i=1:num_classes_test 
        for j=1:num_examples_test
            test_wzr = cell2mat(test_feats(i,j));  
            if is_empty_cell(test_wzr) continue; end
            
            min_DTW = Inf; class_idx = -1;    
            for k=1:num_classes
                for l=1:num_examples
                    tr_wzr = cell2mat(train_feats(k,l));  
                    if is_empty_cell(tr_wzr) continue; end
                    
                    Cx = test_wzr; Cwzr = tr_wzr; Nwzr = [size(Cwzr,1)];
                    [D_DTW nr] = dtw( Cx, Cwzr, Nwzr ); % oblicz najmniejsza odleglosc miedzy 
                                                        % rozpoznawanym slowem a
                                                        % wzorcami slow pierwszej klasy
                                                        
                    if D_DTW < min_DTW
                        min_DTW = D_DTW;
                        class_idx = k;
                    end
                end
            end
            confusion_matrix(i, class_idx) = confusion_matrix(i, class_idx) + 1;
         end
    end   

    confusion_matrix
    accuracy = sum(diag(confusion_matrix))./sum(sum(confusion_matrix)).*100;
    fprintf(1, 'Skutecznosc rozpoznawania za pomoca algorytmu DTW na zbiorze testowym wynosi %f %%\n', accuracy);
    fprintf(1, 'Rozpoznawanie za pomoca metody DTW zajelo %f sekund.\n', toc());

    %zapisz rezultaty na dysku    
    save_filename = strcat(experiment_name, '/', 'dtw_confusion_matrix.mat' );
    if is_octave()
        save('-mat', save_filename, 'confusion_matrix')
    else
        save(save_filename, 'confusion_matrix', '-mat')
    end

