% Przyklad 14.0X
% Rozpoznawanie izolowanych cyfr od 0 do 9 za pomoca modeli HMM

function [] = rozpoznawanie_HMM_melcepstrum(experiment_name)

    load(strcat(experiment_name, '/testowy_melcepstrum.mat'));
    load(strcat(experiment_name, '/hmm_models.mat'));
    feats = melfeats;
    [num_classes, num_examples] = size(feats);
    confusion_matrix = zeros(num_classes, num_classes); % macierz pomylek
 
    tic();
  
    for i=1:num_classes %sprawdz kazdy model dla kazdego przypadku testowego
        for j=1:num_examples
            o = cell2mat(feats(i,j));  
            if is_empty_cell(o) continue; end
            
            max_llike=-Inf;
            mdl_idx=-1;    
            for k=1:num_classes
                hmm = hmms(k); F = size(hmm.mu, 1); priors = [1 zeros(1, F-1)]';                      
                B = compute_pdfs(o, hmm);
                % oblicz prawdopodobienstwo najbardziej prawdopodobnej sciezki
                [llike, best_path] = hmm_viterbi(priors, B, hmm.A);
                % lub klasyfikuj na podstawie prawdopodobienstwa calkowitego
                %[llike, aa, bb, gg] = hmm_fwdback(priors, B, hmm.A, false);
                if llike > max_llike
                    max_llike = llike;
                    mdl_idx = k;
                end
             end
             confusion_matrix(i, mdl_idx) = confusion_matrix(i, mdl_idx) + 1;
         end
    end   

    confusion_matrix
    accuracy = sum(diag(confusion_matrix))./sum(sum(confusion_matrix)).*100;
    fprintf(1, 'Accuracy on test set using HMMs is %f %%\n', accuracy);
    fprintf(1, 'Recognition by HMMs took %f seconds.\n', toc());

    %zapisz resultaty na dysku    
    save_filename = strcat(experiment_name, '/', 'hmm_confusion_matrix.mat' );
    if is_octave()
        save('-mat', save_filename, 'confusion_matrix')
    else
        save(save_filename, 'confusion_matrix', '-mat')
    end
    
end


