% Skrypt glowny uruchamiajacy wykonanie nastepujacych etapow:
%
% 1) ekstrakcji cech melcepstralnych (zbior uczacy i testowy)
% 2) rozpoznawania za pomoca DTW
% 3) estymacji modeli HMM 
% 4) rozpoznawania za pomoca HMM
%
% Przed uruchomieniem skryptu 'run' wejdz do katalogu w wybranym
% srodowisku uruchomieniowym {matlab, octave} przez wpisanie w 
% oknie komend cd 'sciezka/do/rozdzial_14' (n.p. C:\teledsp\rozdzial_14)
%
% Koniecznym moze okazac sie rowniez dodanie ww. katalogu do sciezki wybranego
% srodowiska uruchomieniowego.

%inicjalizacja ogolnych ustawien srodowiska
clear all; clc; init_environment();

% ========================= Parametry eksperymentu ======================== 

experiment_name='exp'; %utworz i zapisz rezulataty w katalogu o takiej nazwie

mkdir(experiment_name);

%1) ========================================================================

% dla kazdego pliku z listy uczacy.list wykonaj parametryzacje zapisujac wyniki
% w katalogu o nazwie experiment_name/uczacy_melcepstrum.mat
disp('-- EKSTRAKCJA CECH ZBIORU UCZACEGO ')
ekstrahuj_melcepstrum('uczacy.list', experiment_name)

% dla kazdego pliku z listy testowy.list wykonaj parametryzacje zapisujac wyniki
% w katalogu o nazwie experiment_name/testowy_melcepstrum.mat
disp('-- EKSTRAKCJA CECH ZBIORU TESTOWEGO ')
ekstrahuj_melcepstrum('testowy.list', experiment_name)

%2) =========================================================================

disp('-- ROZPOZNAWANIE ZA POMOCA KLASYFIKATORA DTW ')
rozpoznawanie_DTW_melcepstrum(experiment_name)

%3) =========================================================================

disp('-- TRENOWANIE HMM ')
trenuj_HMM_melcepstrum(experiment_name)

%4) =========================================================================

disp('-- ROZPOZNAWANIE ZA POMOCA HMM ')
rozpoznawanie_HMM_melcepstrum(experiment_name)


