% Przyklad 17.10
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

function Y=delay_speaker(x, fp, N, l, theta)
%% Y=delay_speaker(x, fp, N, l, theta)
%
% x - sygnal wejsciowy, fp - czestotliwosc probkowania
% N - liczba kanalow, l - odleglosc glosnikow, theta - kat wiazki
% Y - wielokanalowy sygnal wyjsciowy
v=340;                                  % predkosc dzwieku
alfa=(theta*pi)/180;                    % stopnie/radiany
d=(l*sin(alfa))/v;                      % opoznienie [s]
M=size(x,1);                            % liczba probek w kanale
for k=1:N
    shf(k)=floor((k-1)*abs(d)*fp);      % wektor opoznien dla
end                                     % glosnikow
if(d<0)                                 % transformacja dla
    shf=fliplr(shf);                    % ujemnego kata wiazki
end
Y = zeros(M,N);
for k=1:N                               % wiazka sterowana
    Y(1+shf(k):M,k)=x(1:M-shf(k));
end
