% Przyklad 17.5
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

function y=gcc_phat(x1, x2)
%% y=gcc_phat(x1, x2)
%
% x1, x2 - sygnaly wejsciowe
% y - wyjscie GCC-PHAT
NFFT = 2*(size(x1,1))-1;                % obliczenie dlugosci FFT
G1=fft(x1,NFFT);                        % widmo X1(f)
G2=fft(x2,NFFT);                        % widmo X2(f)
G12=G1.*conj(G2);                       % iloczyn X1(f)X2(f)*
den=max(abs(G12),1e-6);                 % modul |X1(f)X2(f)*|
G=G12./den;                             % X1(f)X2(f)*/|X1(f)X2(f)*|
g=real(ifft(G));                        % transformacja w dziedzine czasu
y=fftshift(g);
