% Przyklad 17.11
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

clear all; clc;                         % przygotowanie obliczen
%------------------------ Parametry macierzy ------------------------------
l=0.02;                                 % odleglosc glosnikow
N=16;                                   % liczba kanalow

thetaA=30;                              % kat wiazki A (-90 - +90)
thetaB=0;                               % kat wiazki B (-90 - +90)
thetaC=-45;                             % kat wiazki C (-90 - +90)
%------------------------ Sygnaly wejsciowe -------------------------------
[x0, fp] = wavread('bird1.wav');        % sygnal A
[x1, fp] = wavread('bird2.wav');        % sygnal B
[x2, fp] = wavread('bird3.wav');        % sygnal C
%----------------------- Generowanie wiazek -------------------------------
Y0=delay_speaker(x0, fp, N, l, thetaA);
Y1=delay_speaker(x1, fp, N, l, thetaB);
Y2=delay_speaker(x2, fp, N, l, thetaC);
%--------------------------------------------------------------------------
Y=(Y0+Y1+Y2)/3;                         % znormalizowana suma wiazek
wavwrite(Y, fp, 'mch_separation.wav');  % zapis wyjscia