% Przyklad 17.2
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

clear all; clc;                         % przygotowanie obliczen
%------------------------ Parametry macierzy ------------------------------
v=340;                                  % predkosc dzwieku [m/s]
l=0.05;                                 % odleglosc mikrofonow [m]
N=8;                                    % liczba mikrofonow
fg=6000;                                % gorna czestotliwosc wykresu [Hz]
M=400;                                  % rozdzielczosc wykresu MxM
%------------------------ Obliczenia czulosci -----------------------------
for m=1:M                               % zmiana czestotliwosci
    f(m)=m*fg/M;                        % wektor czestotliwosci
    for p=1:M                           % zmiana fazy
        theta(p)=(pi*(p/M))-pi/2;       % wektor fazy
        sum=0;
        for k=0:N-1                     % obliczenie czulosci macierzy
            sum=sum+exp(i*2*pi*f(m)*k*l*sin(theta(p))/v);
        end
        y(m,p)=abs(sum/N);              % modul/N
    end
end
%----------------------------- Wykres -------------------------------------
fr=linspace(0,fg,M);                    % przestrzen czestotliwosci dla wykresu
ph=linspace(-90,90,M);                  % przestrzen fazy dla wykresu
%surf(ph,fr,y);                         % wykres 3D
pcolor(ph,fr,y); colorbar;              % wykres 2D
shading interp;                         % cieniowanie wykresu
ylabel('Czestotliwosc (Hz)'); xlabel('Faza (stopnie)'); zlabel('Amplituda');
title(['N=',num2str(N),', l=',num2str(l*100),'cm']); grid on;