% Przyklad 17.8
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

clear all; clc;                             % przygotowanie obliczen
%------------------------ Parametry macierzy ------------------------------
l=0.02;                                     % odleglosc mikrofonow w macierzy
%theta=30;                                  % kat wiazki (-90 - +90)
%--------------------------------------------------------------------------
[X, fp] = wavread('mch_noise.wav');
%------------------------------ TDOA --------------------------------------
N=size(X,2);                               % liczba kanalow
theta=tdoa(X(:,1), X(:,N), fp, (N-1)*l, 1) % obliczenie kata na podstawie TDOA
%---------------------- Narrowband Beamforming ----------------------------
%wagi filtru pasmowo-przepustowego (Hamming 10rzad 2kHz-16kHz)
hnb=[-0.00965926 0 -0.0309026 -0.153538 0.18252 0.603916 0.18252 -0.153538 -0.0309026 0 -0.00965926];
%----------------------- Broadband Beamforming ----------------------------
%wagi dla delay-sum [1 0 0 0 ...]
hbb=[1];
%--------------------------------------------------------------------------
fsum=filter_sum(X, fp, hnb, l, theta);      % filter-sum
%fsum=delay_sum(X, fp, l, theta);           % delay-sum
%--------------------------- Spektrogram ----------------------------------
amin=1000;                                  % dynamika spektrogramu

[C,f,t]=specgram(X(:,1),1024,fp,256,192);   % pojedynczy kanal
subplot(2,1,1);
bmin=max(max(abs(C)))/amin;
imagesc(t,f,20*log10(max(abs(C),bmin)/bmin));
axis xy; xlabel('Czas (s)'); ylabel('Czestotliwosc (Hz)'); colorbar;

[C,f,t]=specgram(fsum,1024,fp,256,192);     % wyjscie filter-sum
subplot(2,1,2);
bmin=max(max(abs(C)))/amin;
imagesc(t,f,20*log10(max(abs(C),bmin)/bmin));
axis xy; xlabel('Czas (s)'); ylabel('Czestotliwosc (Hz)'); colorbar;
%--------------------------------------------------------------------------
wavwrite(fsum, fp, 'fs_noise.wav');         % zapis wyjscia do pliku
sound(fsum, fp);                            % odtwarzanie wyjscia

