% Przyklad 17.6
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

function theta=tdoa(x1, x2, fp, l, M)
%% theta=tdoa(x1, x2, fp, l, M)
%
% x1, x2 - sygnaly wejsciowe, fp - czestotliwosc probkowania
% l - odleglosc mikrofonow, M - liczba zrodel dzwieku
v=340;                                  % predkosc dzwieku [m/s]
xx=gcc_phat(x1,x2);                     % korelacja GCC-PHAT
[val,i]=sort(xx,'descend');             % sortowanie M-maksimow
S=size(x1,1);                           % dlugosc sygnalu
for k=1:M                               % iteracja po zrodlach dzwieku
    shf=S-i(k);                         % obliczenie kata wiazki
    d=shf/fp;
    alfa=asin((d*v)/(l));
    theta(k)=alfa*180/pi;
end