function pred_I(img_in, row);
% pred_I(img_in, row);
%
% Dzialanie predykcji wewnatrzobrazowej;
% Funkcja wyznacza blad predykcji na podstawie wartosci poprzedniej probki;
%
% img_in - obraz wejsciowy (monochromatyczny);
% row - numer wiersza;
%
% Przyklad 18.1.
% m-plik (funkcyjny): pred_I.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 18. Kompresja obrazow. 
% Autor rozdzialu: Marek Domanski.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2014 r./MD.

dim = size(img_in);
if (row < 1 || row > dim(1)),
    fprintf('Wybrano numer wiersza spoza dozwolonego zakresu \n');
end;
img_out = img_in;
img_out(row,:)= 0;
A = double(img_in(row,:));  % probki z wybranego wiersza

% Predykcja wartosci biezacej probki na podstawie poprzedniej.
B = [128, A];
C = A-B(1:length(A));

    figure(1);
        imagesc(img_out, [0 255]); colormap(gray); axis off; axis image;
            title('Obraz oryginalny z zaznaczonym wybranym wierszem');
    figure(2);
        hist(A(1,:),256);
            title('Histogram wartosci probek w wybranym wierszu');
    figure(3);
        hist(C(1,:),513);
            title('Histogram bledu predykcji probek w wybranym wierszu');

% KONIEC PRZYKLADU 18.1.