% PRZYKLAD 18.4
% plik: przyklad_18_4.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 18. Kompresja obrazow. 
% Autor rozdzialu:  Marek Domanski.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2014 r./MD.

clc; clear; close all;

% wczytujemy obraz odniesienia:
ref_img=double(imread('lena.tif'));

% wprowadzenie "ruchu":
cur_img=ref_img(end:-1:1,end:-1:1);      % w tym przypadku dosc radykalnie ...

% estymacja ruchu:
d=8;                                     % dlugosc boku kwadratowego bloku obrazu;
A=motionEstES(cur_img, ref_img, d, 4*d); % uwaga: to moze potrwac kilka minut...

% wyznaczenie obrazu predykcji na podstawie obrazu odniesienia i wyznaczonych wektorow ruchu:
img_out=motionComp(ref_img,A,d);

% wyswietlanie wynikow:
    figure(1);
        subplot(2,3,1); 
            imagesc(ref_img,[0 255]);colormap(gray); axis image;
                title('Obraz odniesienia');
        subplot(2,3,2); 
            imagesc(cur_img,[0 255]);                axis image;
                title('Obraz kodowany');
        subplot(2,3,3); 
            imagesc(img_out,[0 255]);                axis image;
                title('Obraz przewidywany');
        subplot(2,3,4); 
            imagesc(abs(cur_img-ref_img),[0 255]);   axis image;
                title('Roznica obrazow kodowanego i odniesienia');  
        subplot(2,3,6); 
            imagesc(abs(cur_img-img_out),[0 255]);   axis image;
                title('Blad predykcji');
                
% skladowe wektorow ruchu:
    figure(2);
        subplot(1,2,1); 
            hist(A(1,:),d*2+1);
                title('Histogram wektorow ruchu skladowej pionowej (y)');
        subplot(1,2,2); 
            hist(A(2,:),d*2+1);
                title('Histogram wektorow ruchu skladowej poziomej (x)');

% histogramy:
    figure(3);
        subplot(2,2,1); 
            hist(ref_img(:),256);
                title('Obraz odniesienia');
        subplot(2,2,2); 
            hist(cur_img(:),256);
                title('Obraz kodowany');
        subplot(2,2,3); 
            hist(cur_img(:)-ref_img(:),512);
                title('Roznica obrazow kodowanego i odniesienia');
        subplot(2,2,4); 
            hist(cur_img(:)-img_out(:),512);
                title('Blad predykcji');

% KONIEC PRZYKLADU 18.4.