function [Ome]=fESPRIT(x,K)
% Przyklad 20.9
% x - analizowany sygnal - suma tlumionych sinusoid o~wartosciach rzeczywistych
% K - zalozona liczba skladowych
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

N = length(x);                     % licza probek sygnalu
L = 2*K;                           % rzad predykcji, liczba skladowych zespolonych
L1 = L+1;
r=xcorr(x,'unbiased');             % do wyboru: 'unbiased', 'biased', 'coeff', 'none'
r = r(N:end);                      % funkcja autokorelacji ryy
R0 = toeplitz( r(1:L+1) );         % macierz autokorelacji Ry0y0
R1 = [ R0(:,2:L1) r(L1+1:-1:2)'];  % macierz autokorelacji Ry0y1
[V,D] = eig(R0);                   % EVD( Ry0y0 )
sigma = min(diag(D));              % minimalna wartosc wlasna
I = eye(L1); J = [zeros(1,L1); I(1:L1-1,1:L1) ];  % macierze I, J
C0 = R0 - sigma*I; C1 = R1 - sigma*J;             % macierze C0= Cy0y0. C1=Cy0y1
S = eig(C0, C1);                                  % EVD( C0, C1) - Matrix-Pencil
S = S( find( abs(S) > 0.5 ) );     % znajdz wartosci zespolone o module > 0.5
Om = atan2( imag(S), real(S) );    % kat liczby zespolonej
Om = sort( Om, 'descend' ); Ome = Om(1:K); % pulsacje (odrzucenie wartosci ujemnych)