function [Ome, de]=fHilbert(x,W)
% Przyklad 20.2
% x = A*cos(Om*n+p).*exp(-d*n)
% W - parametr wyboru okna: 0-Hanning, 1-Blackman
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

N = length(x);                    % dlugosc sygnalu
if(W==1) win = hanning(N)'; end   % wybor okna
if(W==2) win = blackman(N)'; end  %
Xh = hilbert(win.*x)./win;        % transformacja Hilberta w dziedzinie czestotliwosci
Om = diff( unwrap( angle(Xh) ) ); % plot(Om), pause % pulsacja chwilowa - zmiany
A = abs(Xh);                      % plot(A), pause % amplituda chwilowa - zmiany
d = -diff( log(A) );              % plot(d), pause % tlumienie chwilowe - zmiany
ind = round( N/2-N/4 : N/2+N/4 ); % obciecie oscylacji na brzegach
Ome = mean(Om(ind));              % usredniona wartosc pulsacji
de = mean(d(ind));                % usredniona wartosc tlumienia
% temp = polyfit(ind,log(abs(Xh(ind))),1); de=-temp(1); % regresja liniowa