% Przyklad 20.1
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

clear all; close all;

%% Parametry sygnalow
N = 500;                        % liczba probek sygnalu
K = 2;                          % liczba skladowych rzeczywistych
SNR = 160;                      % stosunek sygnal/szum [decybele], od 20 do 160
Om = [12.345 77.89 111.22 145.67 ]*(2*pi)/N, % pulsacje - numery prazkow DFT
d = [0.001 0.01 0.10 0.20 ],    % tlumienia
                                % WAZNE: dla fPisarenko i fESPRIT wymagane d=0
%d = [ 0 0 0 0 ];               % dla metod fPisarenko i fESPRIT
A = [4.3 3.3 2.3 1.3 ];         % amplitudy
p = [-pi/11 -pi/7 -pi/5 -pi/3]; % fazy

%% Generacja sygnalu testowego
n = 0:N-1; x = zeros(1,N);
for k=1:K
x = x + A(k)*cos(Om(k)*n+p(k)).*exp(-n*d(k));
end
y = awgn( x, SNR);              % dodanie szumu
plot(y); title('Analizowany sygnal'); xlabel('n'); grid; pause

%% Dekompozycja EVD
L = 2*K+20;                     % wymiar macierzy autokorelacji
ryy=xcorr(y,'unbiased');        % do wyboru: 'unbiased', 'biased', 'coeff', 'none'
ryy = ryy(N:end);               % z powodu symetrii, bierzemy tylko polowe
Ryy = toeplitz( ryy(1:L+1) );   % zbudowanie macierzy Rxx
[U, D ] = eig( Ryy );           % EVD( Rxx )
sigma = diag( D );              % wartosci wlasne
[sigma, indx] = sort( sigma, 'descend' );
stem( sigma ), title('Warosci wlasne'); grid, pause
subplot(411); plot(U(:,indx(1))), title('Wektor wlasny 1'); grid,
subplot(412); plot(U(:,indx(2))), title('Wektor wlasny 2'); grid,
subplot(413); plot(U(:,indx(3))), title('Wektor wlasny 3'); grid,
subplot(414); plot(U(:,indx(4))), title('Wektor wlasny 4'); grid,
pause