
% Demodulacja sygnalu za pomoca filtru Hilberta (przesuwnik fazowy o -90 stopni)
% Wersja 2
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

clear all; close all;

% Generacja sygnalu
  N=1000;
  fpr=1000;
  dt=1/fpr;
  t=dt*(0:N-1);

  dA = 0.5;
  A = 10*(1+dA*sin(2*pi*2*t));

 %f = 50*ones(1,N);
 %fi = 2*pi*f.*t;
  f0 = 250; df=200; fm=4;
  fi=2*pi*(f0*t-df/(2*pi*fm)*cos(2*pi*fm*t));

  xr= A.*cos(fi);

% Filtr Hilberta

if(0) % Matlab
   y = hilbert(xr);
end
if(0) % W dziedzinie czestotliwosc z definicja przesuwnika fazowego
   Xr = fft(xr);
   Xr(1)=0; Xr(N/2+1)=0;
   Xr(2:N/2) = -j*Xr(2:N/2); 
   Xr(N/2+2:N) = j*Xr(N/2+2:N); 
   xi = ifft(Xr);
   y = xr+j*xi;
end
if(1) % W dziedzinie czasu
    M = 50; K=2*M+1;
    n = -M : M;
    h=(1-cos(pi*n))./(pi*n); h(M+1)=0; % odpowiedz impulsowa
  % h=sin(2*pi*100/fpr*n)./(pi*n); h(M+1)=2*100/fpr;
    
    w = kaiser(2*M+1,7)';
    h = h.*w;
    stem(n,h);pause
    f = 0:fpr/2;
    
    %z = exp(-j*2*pi*f/fpr);
    %H = polyval(h,z);
    %H = H .* exp(j*2*pi*f*(M*dt));
    
    H = fft(h,N);
    f0 = 1/(N*dt); f=f0*(0:N-1);
    H = H .* exp(j*2*pi*f/fpr*M);
    
    plot(f,20*log10(abs(H))); pause
    plot(f,unwrap(angle(H))); pause
    xi = conv(xr,h);
    xi = xi(K:end-(K-1));
    xr = xr(M+1:end-M);
    t = t(M+1:end-M);
    A = A(M+1:end-M);
    plot(xr,xi); pause
    y = xr+j*xi;
 
end    

% Demodulacja amplitudowa i czestotliwosciowa

Ae= abs(y);
fe = (diff(unwrap(angle(y))) ./ diff(t)) /(2*pi);

plot(t,A,'r',t,Ae,'b'); grid; title('A(t)'); pause
plot(t(2:end),fe,'b'); grid; title('f(t)'); pause
