% Przyklad 21.09
function [w,r] = dziel_wiel_bin(p,q)
% Funkcja dzieli wielomiany zadane zmiennymi p i q i zwraca wynik w oraz reszte r
% Wspolczynniki wielomianow sa reprezentowane od najwyzszej potegi:
% x^3 + x + 1 = [1 0 1 1]
% Spolszczona wersja programu dostarczonego wraz z ksiazka
% T.K. Moona "Error Correction Coding"

m = length(p); n = length(q); w = 0;
t = 2;	% GF(2) - wspolczynniki binarne
b1inv = mod(q(1)^(t-2),t);
for j=1:m-n+1
    w (j) = mod(p(j)*b1inv,t);
    for l=2:n
        p(l+j-1) = mod(p(l+j-1) - w(j)*q(l),t);
    end
end
r = mod(p(m-n+2:m),t);
if(all(r==0))
    r = 0;
end