% Przyklad 21.12
function [Gniesyst, Gsyst] = gen_mac_wiel(g,n)
% Funkcja wytwarza macierze generujace kodow niesystematycznego i
% systematycznego dla wielomianu generujacego zadanego zmienna g
%
% Wspolczynniki wielomianow sa reprezentowane od najwyzszej potegi:
% x^3 + x + 1 = [1 0 1 1]

r = length(g) - 1; k = n - r;
if(k>n)
    disp('Bledne dane, k>n!');
else
    fprintf('Parametry kodu (%d,%d)\n',n,k);
    Gniesyst = [];
    for i=1:k
        u = zeros(1,k);
        u(i) = 1;
        Gniesyst = [Gniesyst; mnoz_wiel_bin(u,g)];
    end
    fprintf('Macierz kodu niesystematycznego:\n');
    disp(Gniesyst);
    Gsyst = [];
    for i=1:k
        u = zeros(1,n);
        u(i) = 1;
        [w,r] = dziel_wiel_bin(u,g);
        Gsyst = [Gsyst; [u(1:k) r]];
    end
    fprintf('Macierz kodu systematycznego:\n');
    disp(Gsyst);
end