% Przyklad 21.06
function x = ham_cod_corr(y)
% Funkcja koryguje slowo zadane zmienna y, otrzymane po przeslaniu poprawnego ciagu kodu
% Hamminga (2^r-1,2^r-1-r) przez kanal

n = length(y); r = log(n+1)/log(2);
if(r~=floor(r) || r~=ceil(r))
    disp('To nie jest odpowiednia dlugosc slowa kodowego!');
else
    k = n-r;
    fprintf('To jest kod (%d,%d) o macierzy testow parzystosci:\n',n,k);
    H = [zeros(r-1,1);1];
    for i=2:2^r-1
        H = [H transpose(dec2bin(i,r)-'0')];
    end
    disp(H);
    syndrom = mod(y*transpose(H),2);
    fprintf('Syndrom dla y = [%s] to s = [%s], zatem:\n',...
        num2str(y),num2str(syndrom));
    if(mean(syndrom) == 0)
        fprintf('przyjmujemy, ze nie wystapilo przeklamanie.\n');
    else
        pozycja = bin2dec(num2str(syndrom));
        fprintf('przyjmujemy, ze przeklamanie wystapilo na pozycji nr %d,\n',...
            pozycja);
        y(pozycja) = mod(y(pozycja)+1,2);
        x=y;
        fprintf('a wyslano slowo kodowe [%s].\n',num2str(y));
    end
end