% Do the actual processing. 
% If you want to en/disable the intermediate output of the name, text1 and text2
% then you can (un)comment the last 5 lines of this file
%
% (c) 2001 Lieven Hollevoet, picmicro@hollie.tk

% Re-use of this code is hereby permitted, as long as
% my name and e-mail address are mentioned in the new
% version.

function [zender, text1, text2] = process(loper, data, naam, text1, text2)

% Fetch data types

blockA = data(loper    : loper+25);
blockB = data(loper+26 : loper+51);
blockC = data(loper+52 : loper+77);
blockD = data(loper+78 : loper+103);

% What do we have?
type = blockB(1:5);

if (type(1:4) == [0 0 0 0]) % We have a group 0A or 0B !
   % Get name segment address code
   name_seg = blockB(15:16);
   % Get the chars
   ascii_1 = blockD(1:8);
   ascii_2 = blockD(9:16);
   
   char_1 = vbin2char(ascii_1);
   char_2 = vbin2char(ascii_2);
   
   % And put'em in the name-string
   if name_seg == [ 0 0 ]
      naam(1:2) = [char_1 char_2];
   elseif name_seg == [ 0 1 ]
      naam(3:4) = [char_1 char_2];
   elseif name_seg == [ 1 0 ]
      naam(5:6) = [char_1 char_2];
   elseif name_seg == [ 1 1 ]
      naam(7:8) = [char_1 char_2];
   end 
elseif (type == [0 1 0 0 0]) % Group 4A, contains time & date
   % Get MJD
   MJD = blockC(1:15)
   
elseif (type == [0 0 1 0 0]) % Group 2A, contains RT
   % Get text segment address code
   text_seg = blockB(13:16);
   % and group A/B flag
   AB_flag = blockB(12);
   
   % Get the chars
   ascii_1 = blockC(1:8);
   ascii_2 = blockC(9:16);
   ascii_3 = blockD(1:8);
   ascii_4 = blockD(9:16);
   
   char_1 = vbin2char(ascii_1);
   char_2 = vbin2char(ascii_2);
   char_3 = vbin2char(ascii_3);
   char_4 = vbin2char(ascii_4);
   
   chars = [char_1 char_2 char_3 char_4];
   
   [text1 text2] = locate_it(chars, text_seg, AB_flag, text1, text2);
   
end

zender = naam;
fprintf('.');
fprintf('\n');
disp(zender);
disp(text1);
disp(text2);
fprintf('\n');
   