 
% Radio FM - tylko dekoder RDS z petla Costasa
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

  clear all; close all;

  fm_param   % wczytanie parametrow
  ifigs = 0;
  
% ##################################################  
% DEKODER SYGNALU RADIA FM  - zsytezowanego lub rzeczywistego
% y = x; clear x;
  [y,fs,Nbits] = wavread('FM_Radio_IQ_250KS.wav');                        % s. zsyntezowany
% [y,fs,Nbits] = wavread('FM_Radio_Krakow_101600kHz_IQ_250KS.wav',10*fs); % s. rzeczywisty z SDR#
  disp('DANE WCZYTANE Z DYSKU!'); pause

  y = y(:,1) + sqrt(-1)*y(:,2);  % IQ --> complex
% y = y(1:2^15);
  
% Obliczenie czestotliwosci chwilowej - demodulacja czestotliwosciowa
  dy = (y(2:end).*conj(y(1:end-1)));
  y = atan2( imag(dy), real(dy) ); clear dy;
  if(ifigs==1) figure, plot(y); title('Sygnal FM'); xlabel('n'); grid; pause; end
  
% ZDEKODOWANIE BITOW SYGNALU RDS
% Filtracja pasmowo-przepustowa wokol czestotliwosci 57 kHz
  y = filter(hBP57,1,y);
  if(ifigs==1)
     figure, plot(y); title('Sygnal po filtrze BP57'); xlabel('n'); grid; pause
  end
  
% Down-sampling 14x
  Mstep = 14; fsnew=fs/Mstep;
  y = y(1:Mstep:end);
  frdsdown = frds-3*fs/14;  % RDS new freq 3428.6 Hz
  
% Petla Costasa - z [7]
  r=y;
  Nr = length(r);
  Ts=1/fsnew; t=Ts:Ts:Ts*Nr;                   % chwile probkowania
  
% fl=500; ff=[0 2*fsymb 4*fsymb fsnew/2]/(fsnew/2); fa=[1 1 0 0];
% h=firpm(fl,ff,fa); h=fliplr(h);              % projekt filtra LowPass #1      
  fl=500; h = fir1(fl,2*fsymb/(fsnew/2));      % projekt filtra LowPass #2
  
  mu=1;                                        % stala adaptacji algorytm LMA
  f0=frdsdown; w0=2*pi*f0;                     % czestotliwosc w obiorniku
  theta=zeros(1,length(t)); theta(1)=0;        % estymowany wektor
  zs=zeros(1,fl+1); zc=zeros(1,fl+1);          % bufory filtrow
  for k=1:length(t)-1                          % z - poprzednie wartosci
    % zs=[zs(2:fl+1), 2*r(k)*sin(w0*t(k)+theta(k))];
    % zc=[zc(2:fl+1), 2*r(k)*cos(w0*t(k)+theta(k))];
      zs(1:fl)=zs(2:fl+1); zs(fl+1)=2*r(k)*sin(w0*t(k)+theta(k));
      zc(1:fl)=zc(2:fl+1); zc(fl+1)=2*r(k)*cos(w0*t(k)+theta(k));
      lpfs(k)=h*zs';                           % wyjscie z filtra SIN
      lpfc(k)=h*zc';                           % wyjscie z filtra COS
      theta(k+1)=theta(k)-mu*lpfs(k)*lpfc(k);  % uaktualnienie wartosci
  end
  if(ifigs==1)
     figure
     plot(t,theta),
     title('Sledzenie fazy za pomoca petli Costasa')
     xlabel('czas'); ylabel('offset fazowy')
  end

% Filtracja LP dopasowana - filtr ksztaltujacy impulsy RDS 
  y = filter( hpsf, 1, lpfc );
  if(ifigs==1)
     figure
     subplot(311); plot(t(1:end-1),lpfs); title('LPFS(t)'); grid;
     subplot(312); plot(t(1:end-1),lpfc); title('LPFC(t)'); grid;
     subplot(313); plot(t(1:end-1),y); title('ypsf(t)'); grid; pause
  end  
  clear theta lpfs;

% Rozruch: znalezienie ujemnego i dodatniego zbocza "zegara"
  nfirst=1000; nlast=2000;
  M=5; M2=(M-1)/2; maxi1 = 1; maxi2 = 1;
  for n = M2+nfirst:nlast-M2
    if( (lpfc(n-2)>0) & (lpfc(n-1)>0) & (lpfc(n+1)<0) & (lpfc(n+1)<0) ) % ujemne zbocze
       if(n~=(maxi1(end)+1)) maxi1 = [ maxi1 n ]; end
    end    
    if( (lpfc(n-2)<0) & (lpfc(n-1)<0) & (lpfc(n+1)>0) & (lpfc(n+1)>0) ) % dodatnie zbocze
       if(n~=(maxi2(end)+1)) maxi2 = [ maxi2 n ]; end
    end  
  end
  
% Znalezienie pierwszego "podwojnego" odcinka >= floor(fsnew/fsymb) = 15
  thres = 12;
  N1=length(maxi1); N2=length(maxi2);
  maxi = [ maxi1 maxi2 ]; maxi = sort(maxi);
  period = maxi(2:end)-maxi(1:end-1),
  [val indx] = find( period >= floor(fsnew/fsymb) ),
  z(1) = 1+maxi(indx(1));
  z(2) = z(1) + period(indx(1));
  offs = floor(0.25*period(indx(1)));
  where(1) = z(2)-offs; 
  
% Probkowanie
  Nlpfc = length(lpfc);
  M=round(fsnew/fsymb); M2=round(0.5*fsnew/fsymb);
  indx = 1; mu = 1000; tau(1) = 0;
  while( where(indx) + M + 1 < Nlpfc )
        n=where(indx);
        if( ((lpfc(n)>0) & (lpfc(n)>lpfc(n-1)) & (lpfc(n)>lpfc(n+1))) | ...
            ((lpfc(n)<0) & (lpfc(n)<lpfc(n-1)) & (lpfc(n)<lpfc(n+1))) )
            where(indx+1) = n + M;
            indx = indx + 1;
        else     
            tau(indx+1) = sign(lpfc(n+1)-lpfc(n-1));
            if(lpfc(n)<0) tau(indx+1)=-tau(indx+1); end
            where(indx+1) = n + M + tau(indx+1);
            indx = indx + 1;
        end    
  end    
  
  if(ifigs==1)
     Nw = length(where); Nlpfc = length(lpfc);
     figure; plot(1:Nlpfc,lpfc(1:Nlpfc),'k',z(1),0,'go',where,0.05*ones(1,Nw),'r*'); grid; pause
  end   

% Zmiana poziomow: {-1, +1} --> {0,1} 
  rdsbits = (sign( lpfc( where ) )+1)/2,
% Dekodowanie roznicowe z uwzglednieniem bi-fazowosci sygnalu
  rdsbits = abs(rdsbits(2:end) - rdsbits(1:end-1)),
  rdsbits = rdsbits';
% Zapisanie odczytanych bitow na dysk - dla programu rds.m L. Hollevoeta
  save FM_Radio_RDS.txt rdsbits /ascii
