% ##################################################
% RADIO FM: KODER - przyklad
% Program fm_koder.m
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

  clear all; close all;
  
  fm_param   % wczytaj parametry

% Wczytaj dwa monofoniczne sygnaly audio
  [x1, fx1, Nbits ] = wavread('mowa44100'); x1=x1.'; % plot(x1);
  [x2, fx2, Nbits ] = wavread('bach44100'); x2=x2.'; % soundsc(x1,fx1);

% Pre-emfaza, ch-ka plaska do 2.1 kHz, potem narastanie 20 dB na dekade
  x1 = filter(b_pre,a_pre,x1); x2 = filter(b_pre,a_pre,x2);

% Nadprobkowanie do czestotliwosci fs
  [N1,D1] = rat(fs/fx1,1e-4); x1 = resample(x1,N1,D1);
  [N2,D2] = rat(fs/fx2,1e-4); x2 = resample(x2,N2,D2);
  Nx = min( length(x1),length(x2) ); n=1:Nx; x1=x1(n); x2=x2(n);
% x1 = zeros(1,Nx); % celach testowych

% Bity RDS do zakodowania
  Nrds = ceil(Nx/(fs/fsymb)); rds = [];
  for k=1:ceil(Nrds/10), rds = [ rds 1 1 1 1 0 0 0 1 1 0 ];
  end
% rds = round(rand(1,Nrds)); % w celach testowych

% Kodowanie roznicowe bitow RDS
  Nrds = length(rds); r = 0;
  for k=2:Nrds, r(k)=abs(rds(k)-r(k-1));
  end
  Nr = ceil(fs/fsymb *length(r));

% Przejscie na impulsy bi-fazowe
  bip = [-1 1; 1 -1 ]; brds = bip( r+1,: ); brds=brds'; brds=brds(:);

% Nadprobkowanie - wstawienie zer i wygladzenie RDS filtrem ksztaltujacym
  uprds = zeros(1,Nr); t = dt*(0:Nr-1);
  clk = abs(diff(sign(sin(2*pi/Tsymb*t))))/2; clk = [clk 0];
  indx=1;
  for n=1:Nr
      if(clk(n)==1) uprds(n)=brds(indx); indx=indx+1;
      end
  end
  prds = conv( uprds, hpsf); prds = prds(1:Nx); % wygladzenie filtrem psf
  clear t clk r brds uprds;

% Zlozenie calkowitego sygnalu radia FM
  n=0:Nx-1; alpha = 2*pi*fpilot/fs*n;
  x =0.9*(x1+x2)+0.1*cos(alpha)+0.9*(x1-x2).*cos(2*alpha)+0.05*prds.*cos(3*alpha);
  A = max(x); x=x/A; clear prds alpha;

% Koncowa modulacja czestotliwosciowa
  fc = 0;      % czestotliwosc nosna radia FM - u nas wokol DC
  kf = 75000;  % glebokosc modulacji czestotliwosci
  x = exp( j*2*pi*( fc/fs*n + kf*cumsum(x)/fs ) ); x=x.';
  I = real(x); Q = imag(x);
  wavwrite([I Q],fs,32,'FM_Radio_IQ_250KS.wav'); % zapisz wynik na dysku
  