function y = bitLoad( snr, noBits )
% y(N/2,1): liczba bitow w i-tym podkanale
% snr(N/2,1): Signal-to-Noise-Ratio w i-tym podkanale
% noBits: liczba bitow, ktora powinna byc zarezerwowana w calej ramce
%   0 - oznacza zarezerwuj tak duzo jak to mozliwe
%   x - oznacza zarezerwuj x bitow w tej ramce

margin = 6;
codingGain = 4.2;

gam = 10^((9.8 + margin - codingGain)/10);

if( noBits == 0 )
    y = log(snr/gam+1)./log(2);         % y = log2( snr/gam +1 );
    y = floor( y );
    idx = find( y > 15 );               % nie wiecej niz 15 bitow w podkanale
    y( idx ) = 15;
    idx = find( y <2 );
    y( idx ) = 0;
else
    x = zeros( 2, length(snr ) );
    x(1,:) = snr;
    currentBR = 0;
    while( noBits > currentBR )
        [ m, i ] = max( x(1,:) );
        if( x( 2, i ) == 0 )            % minimum 2 bity w podkanale albo 0
            x( 2, i ) = 2;
            currentBR = currentBR + 2;
            x( 1, i ) = snr( i ) - gam * ( 2^x(2,i) - 1 );
            if( x( 1, i ) < 0 )
                x( 2, i ) = 0;
                currentBR = currentBR - 2;
            end
        elseif( x( 2, i ) >= 15 )       % nie wiecej niz 15 bitow w podkanale
            x( 1, i ) = -1e10;
        else                            % +1 bit
            x( 2, i ) = x( 2, i ) + 1;
            currentBR = currentBR + 1;
            x( 1, i ) = snr( i ) - gam * ( 2^x(2,i) - 1 );
            if( x( 1, i ) < 0 )
                x( 2, i ) = x( 2, i ) - 1;
                currentBR = currentBR - 1;
            end
        end
        if( sum( x( 1,: ) <= 0 ) >= length( x(1,:) ) )
            y = x( 2, : )';
            return;
        end
    end
    y = x( 2, : );
end
