% estymacja IR w obecnosci szumu AWGN -120 dBm/Hz, sygnal 23 dBm
clear all;
close all;
addpath ../

N = 512;    % dlugosc ramki
Le = 16;    % dlugosc filtru TEQ
Lp = 32;    % dlugosc prefiksu

% identyfikacja kanalu:
trType = 0;                         % estymacja kanalu
mask = 2*ones( 1, N/2 );         % maska oblozenia bitow
teqIR = [ 1, 0, 0, 0, 0, 0, 0, 0 ];   % TEQ - delta Kroneckera
D = 0;                               % opoznienie w dziedzinie czasu
FEQ = ones( 1, N/2 );           % FEQ -  trywialny
h1 = adsl( 2, trType, mask, teqIR, D, FEQ, 'AWGN' );   % estymacja IR kanalu
h500 = adsl( 500, trType, mask, teqIR, D, FEQ, 'AWGN' );   % estymacja IR kanalu
% h50000 = adsl( 50000, trType, mask, teqIR, D, FEQ, 'AWGN' );   % estymacja IR kanalu

t=1:length(h1);
% plot( t, h1, 'b', t, h500, 'k', t, h50000, 'r' ); 
figure( 1 ), plot( t, h1, 'b', t, h500, 'k' ); 
xlabel( 'probki'), ylabel( 'amplituda' ); legend( 'x1', 'x500', 'x50000' );
print -dpng ir_stim.png

figure( 2 ), plot( t, h1, 'b', t, h500, 'k' ); 
axis( [300, 500, -0.2e-3, 0.4e-3] )
xlabel( 'probki'), ylabel( 'amplituda' ); legend( 'x1', 'x500', 'x50000' );
print -dpng ir_stim_zoom.png
