% ISI - bez szumu addytywnego
clear all;
close all;
addpath ../

N = 512;    % dlugosc ramki
Le = 16;    % dlugosc filtru TEQ
Lp = 32;    % dlugosc prefiksu

load ir;     % load impulse response of channel
h = ir2;

x = [ zeros( 1, N ), randn( 1, N ), zeros( 1, N ) ];
figure( 1 ), plot( x );
xlabel( 'probki' ); ylabel( 'amplituda' );
title( 'ISI - sygnal przed kanalem' );
print -dpng isi1.png

y = filter( h, 1, x );
figure( 2 ), plot( y );
xlabel( 'probki' ); ylabel( 'amplituda' );
title( 'ISI - kanal bez korekcji' );
print -dpng isi2.png

[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
y = filter( teqIR, 1, y );
figure( 3 ), plot( y );
title( 'ISI - kanal z korekcja' );
xlabel( 'probki' ); ylabel( 'amplituda' );
print -dpng isi3.png

sir = filter( teqIR, 1, h );
n = 1:length(h);
figure( 4 ), plot( n, h/max(h), 'r', n, sir/max(sir),'b' );
xlabel( 'probki' ); ylabel( 'amplituda' ); legend( 'h', 'sir' );
print -dpng isi4.png
