% ISI - bez szumu addytywnego
clear all;
close all;
addpath ../

N = 512;    % dlugosc ramki
Le = 16;    % dlugosc filtru TEQ
Lp = 32;    % dlugosc prefiksu

load ir;     % load impulse response of channel
h = ir2;

x = [ zeros( 1, N ), randn( 1, N ), zeros( 1, N ) ];
y = filter( h, 1, x );

% odpowiedz impulsowa kanalu
figure(1), plot( h ); 
title( 'ISI - kanal bez korekcji' );
xlabel( 'probki' ); ylabel( 'amplituda' );

% charakterystyka czestotliwosciowa kanalu
figure(2), freqz(h);

% odpowiedz impulsowa filtru TEQ
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
y = filter( teqIR, 1, x );
figure(3), plot( teqIR ); 
title( 'TEQ - korektor' );
xlabel( 'probki' ); ylabel( 'amplituda' );

% charakterystyka czestotliwosciowa kanalu
figure(4), freqz(teqIR);

% odpowiedz impulsowa skroconego kanalu
sir = filter( teqIR, 1, h );
figure( 5 ), plot( sir );
title( 'SIR' );
xlabel( 'probki' ); ylabel( 'amplituda' );

% charakterystyka czestotliwosciowa SIR
figure( 6 ), freqz( sir );

% kanal vs skrocony kanal
n = 1:length(h);
figure( 7 ), plot( n, h/max(h), 'r', n, sir/max(sir),'b' );
xlabel( 'probki' ); ylabel( 'amplituda' ); legend( 'h', 'sir' );

figure( 666 );
title( 'konstelacja QAM32' );
print -dpng awgn-qam.png
