function y = bitLoad( snr, noBits )
% y(N/2,1): number of bits in i-th subchannel
% snr(N/2,1): Signal-to-Noise-Ratio in i-th subchannel 
% noBits: number of bits that should be allocated in this frame
%   0 - means allocate as many bits as possible
%   x - allocate x bits in this frame

margin = 6;
codingGain = 4.2;

gam = 10^((9.8 + margin - codingGain)/10);

if( noBits == 0 )
    y = log(snr/gam+1)./log(2); %y = log2( snr/gam +1 );
    y = floor( y );
    idx = find( y > 15 ); % no more then 15 bit/channel
    y( idx ) = 15;
    idx = find( y <2 );
    y( idx ) = 0;
else
    x = zeros( 2, length(snr ) );
    x(1,:) = snr;
    currentBR = 0;
    while( noBits > currentBR )
        [ m, i ] = max( x(1,:) );
        if( x( 2, i ) == 0 )    %minimum 2 bits
            x( 2, i ) = 2;
            currentBR = currentBR + 2;
            x( 1, i ) = snr( i ) - gam * ( 2^x(2,i) - 1 );
            if( x( 1, i ) < 0 )
                x( 2, i ) = 0;
                currentBR = currentBR - 2;
            end
        elseif( x( 2, i ) >= 15 ) %max 15 bits/channel
            x( 1, i ) = -1e10;
        else    % plus one bit
            x( 2, i ) = x( 2, i ) + 1;
            currentBR = currentBR + 1;
            x( 1, i ) = snr( i ) - gam * ( 2^x(2,i) - 1 );
            if( x( 1, i ) < 0 )
                x( 2, i ) = x( 2, i ) - 1;
                currentBR = currentBR - 1;
            end
        end
        if( sum( x( 1,: ) <= 0 ) >= length( x(1,:) ) )  % end condition
            y = x( 2, : )';
            return;
        end
    end
    y = x( 2, : );
end


