clear all;
close all;

N = 512;    % dlugosc ramki
Le = 16;    % dlugosc filtru TEQ
Lp = 32;    % dlugosc prefiksu

% identyfikacja kanalu:
trType = 0;                         % estymacja kanalu
mask = 2*ones( 1, N/2 );         % maska oblozenia bitow
teqIR = [ 1, 0, 0, 0, 0, 0, 0, 0 ];   % TEQ - delta Kroneckera
D = 0;                               % opoznienie w dziedzinie czasu
FEQ = ones( 1, N/2 );           % FEQ -  trywialny
h = adsl( 500, trType, mask, teqIR, D, FEQ, 'AWGN' );   % estymacja IR kanalu

% obliczanie SNR
clear adsl                            % clear persistant variables
trType = 1;                         % estymacja SNR
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
%teqIR = T23_2( h, Lp, Le, D );
%teqIR = [ 1; zeros( 7, 1 ) ];
sir = conv( teqIR, h );            % shortened channel impulse response
FEQ = fft( sir(1:N) );
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
snr = adsl( 512, trType, mask, teqIR, D, FEQ, 'AWGN' );
figure( 3 ); plot( 10*log10( snr ) );

% bit loading
bit1 = bitLoad( snr, 0 );

figure( 4 ); plot( 10*log10( snr ), 'k' );
axis( [0 255, 0, 50] );
title( 'signal-to-nosie-ratio' );
xlabel( 'subchannel' );
ylabel( 'snr [dB]' );

figure( 5 ), plot( 1:256, bit1, 'b');
axis( [0, 255, 0, 15] );
title( 'bit load' );
xlabel( 'subchannel' );
ylabel( 'no. of bits' );

% transmisja danych + bledy
clear adsl                            % clear persistant variables
trType = 2;                         % estymacja BER
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
sir = conv( teqIR, h );            % shortened channel impulse response
FEQ = fft( sir(1:N) );
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
mask = bit1;
figure,
ber = adsl( 8, trType, mask, teqIR, D, FEQ, 'AWGN');


clear adsl                            % clear persistant variables
% transmisja danych + QAM
% mask(1:84) = 0;
% mask(86:end) = 0;
mask(1:19) = 0;
mask(21:end) = 0;
ber = adsl_qam( 512, trType, mask, teqIR, D, FEQ, 'AWGN' );

print -dpng qam_awgn.png