clear all;
close all;
addpath ../

N = 512;    % dlugosc ramki
Le = 16;    % dlugosc filtru TEQ
Lp = 32;    % dlugosc prefiksu

% identyfikacja kanalu:
trType = 0;                         % estymacja kanalu
mask = 2*ones( 1, N/2 );         % maska oblozenia bitow
teqIR = [ 1, 0, 0, 0, 0, 0, 0, 0 ];   % TEQ - delta Kroneckera
D = 0;                               % opoznienie w dziedzinie czasu
FEQ = ones( 1, N/2 );           % FEQ -  trywialny
h = adsl( 512, trType, mask, teqIR, D, FEQ, 'AWGN' );   % estymacja IR kanalu

% obliczanie SNR
clear adsl                            % clear persistant variables
trType = 1;                         % estymacja SNR
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
sir = conv( teqIR, h );            % shortened channel impulse response
FEQ = fft( sir(1:N) );
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
snrAWGN = adsl( 512, trType, mask, teqIR, D, FEQ, 'AWGN' );

clear adsl                            % clear persistant variables
trType = 1;                         % estymacja SNR
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
sir = conv( teqIR, h );            % shortened channel impulse response
FEQ = fft( sir(1:N) );
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
snrAWGNNBI = adsl( 512, trType, mask, teqIR, D, FEQ, 'AWGN+NBI' );
figure( 2 ); plot( 1:256, 10*log10( snrAWGN ), 'b', 1:256, 10*log10( snrAWGNNBI ), 'r' );
title( 'szum: AWGN, AWGN+NBI' ); xlabel( 'podkanaly czestotliwosciowe' ), ylabel( 'SNR' );
legend( 'AWGN', 'AWGN+NBI' );

print -dpng awgn_nbi.png

% notch filter?