function [ teq, Dopt ]= AdslTEQ( h, Le, Ld, D )
% h    - odpowied? impulsowa kana?u)
% Le   - zadana d?ugo?? filtra skracaj?cego (korektora) TEQ
% Ld   - zadana d?ugo?? odpowiedzi impulsowej kana?u po skr?ceniu
% D    - zadana liczba pr?bek op?nienia skr?conej odpowiedzi impulsowej
% e    - obliczone wsp?czynniki filtra skracaj?cego
% Dopt - obliczone optymalne op?nienie (opcjonalnie)

Lh = length(h);                   % d?ugo?? odpowiedzi impulsowej kana?u
H = zeros(Le, Lh+Le-1);
for k=1:Le
    H(k, k:k+Lh-1) = h;           % macierz "splotowa" kana?u
end

Dhmax = find(h==max(abs(h)));     % numer pr?bki, dla kt?rej odpowied? impulsowa ma maksimum
if(D~=0) Dmin=D; Dmax=D;          % nie szukaj lepszego op?nienia dla skr?conej odpowiedzi impulsowej
else     Dmin=0; Dmax=Dhmax+Le;   % szukaj optymalnego op?nienia dla skr?conej odpowiedzi impulsowej
end

E0min=0;                          % p?tla: poszukiwanie optymalnego op?nienia
for d = 0 : Dmax
    rect = [zeros(1,d),ones(1,Ld),zeros(1,Lh+(Le-1)-Ld-d)]; % prostok?tne okno, w kt?rym ma si? zmie?ci? skr?cona odpowied? impulsowa
    W1 = diag(rect);		          % umieszczenie okna na przek?tnej macierzy
    W0 = diag(1-rect);	          % umieszczenie jego "odwr?cenia" (1 -> 0, 0 -> 1) na przek?tnej macierzy
    X1  = H*W1*H';
    G   = chol(X1);
    X0 = H*W0*H';
    T  = inv(G)'*X0*inv(G);
    [V,D] = eig(T);
    LambdaMin = min(diag(D));
    LambdaMinIdx = find(diag(D)==LambdaMin);
    e = V(:,LambdaMinIdx)' * inv(G)';
    E0 = e*X0*e';
	 if((E0min==0) | (E0 < E0min))
		 E0min = E0;
       emin = e;
       Dopt = d;
	 end
end
teq = emin;
