clear all;
close all;

N = 512;    % dlugosc ramki
Le = 16;    % dlugosc filtru TEQ
Lp = 32;    % dlugosc prefiksu

% identyfikacja kanalu:
trType = 0;                         % estymacja kanalu
mask = 2*ones( 1, N/2 );         % maska oblozenia bitow
teqIR = [ 1, 0, 0, 0, 0, 0, 0, 0 ];   % TEQ - delta Kroneckera
D = 0;                               % opoznienie w dziedzinie czasu
FEQ = ones( 1, N/2 );           % FEQ -  trywialny
h = adsl( 500, trType, mask, teqIR, D, FEQ, 'AWGN' );   % estymacja IR kanalu

% obliczanie SNR
clear adsl                            % clear persistant variables
trType = 1;                         % estymacja SNR
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
%teqIR = T23_2( h, Lp, Le, D );
%teqIR = [ 1; zeros( 7, 1 ) ];
sir = conv( teqIR, h );            % shortened channel impulse response
FEQ = fft( sir(1:N) );
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
snr = adsl( 512, trType, mask, teqIR, D, FEQ, 'AWGN' );

% bit loading
bit1 = bitLoad( snr, 0 );

% transmisja danych + bledy
clear adsl                            % clear persistant variables
trType = 2;                         % estymacja BER
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
sir = conv( teqIR, h );            % shortened channel impulse response
FEQ = fft( sir(1:N) );
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
mask = bit1;
figure,
ber = adsl( 8, trType, mask, teqIR, D, FEQ, 'Impulse');

print -dpng qam_awgn.png