function noiseNotch = narrowNoiseGen( fs, N, noiseNotchFreq, noiseType, noiseMod, rndState )
% typ szumu 'AM', 'FM'
%   'AM' - amplitudowo modulowany
%   'FM' - czestotliwosciowo modulowany

rand( 'state', rndState );
L=512;
if( 1 == strcmp( 'AM-MOD', noiseType ) )
    r = -1 + 2 * rand( 1, N );
    Wn = noiseMod/fs
    b = fir1( L, Wn, hamming( L+1 ) );
    r = filter( b, 1, r );
    noiseNotch = modulate( r, noiseNotchFreq, fs, 'am', noiseMod/fs*2*pi )';
elseif( 1 == strcmp( 'AM-FIR', noiseType ) )
    r = -1 + 2 * rand( 1, N );
    Wn = [noiseNotchFreq*2/fs - noiseMod/fs noiseNotchFreq*2/fs + noiseMod/fs];
    b = fir1( L, Wn, hamming( L+1 ) );
    noiseNotch = filter( b, 1, r )';
elseif( 1 == strcmp( 'FM', noiseType ) )
    if( noiseMod == 0 )
        r = zeros( 1, N );
        noiseNotch = modulate( r, noiseNotchFreq, fs, 'fm', 0 )';
    else
        r = rand( 1, ceil( N/(fs/noiseMod) +1 ) )*2-1;
        r = interp( r, fs/noiseMod );
        r(N+1:end)  = [];
        noiseNotch = modulate( r, noiseNotchFreq, fs, 'fm', noiseMod/fs*2*pi )';
    end
end
