% przyklad 23.3

clear all;
close all;

N = 512;                                % dlugosc ramki
Le = 16;                                % dlugosc filtru TEQ
Lp = 32;                                % dlugosc prefiksu

% etap 1, identyfikacja kanalu:
trType = 0;                             % estymacja kanalu
mask = 2*ones( 1, N/2 );                % maska (estymowane wszystkie podkanaly)
teqIR = [ 1, 0, 0, 0, 0, 0, 0, 0 ];     % ,,pusty'' TEQ - delta Kroneckera
D = 0;                                  % opoznienie wprowadzane przez kanal
FEQ = ones( 1, N/2 );                   % ,,pusty'' FEQ
h = adsl( 500, trType, mask, teqIR, D, FEQ, 'AWGN' );   % estymacja IR kanalu

% etap 2, obliczanie SNR
clear adsl                              % kasowanie zmiennych persistant
trType = 1;                             % estymacja SNR
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 ); % wyznaczanie korektora TEQ
sir = conv( teqIR, h );                 % obliczanie skroconej odpowiedzi impulsowej
FEQ = fft( sir(1:N) );                  % wyznaczanie korekora FEQ
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
snr = adsl( 512, trType, mask, teqIR, D, FEQ, 'AWGN' ); % estymacja wartosci SNR

% wizualizacja wynikow: SNR, przydzial bitow
figure( 1 ); plot( 10*log10( snr ), 'k' );
axis( [0 255, 0, 50] ); title( 'SNR' );
xlabel( 'nr podkanalu' ); ylabel( 'snr [dB]' );

bit = bitLoad( snr, 0 );                % przydzial bitow - scenariusz ,,maksimum bitrate''
figure( 2 ), plot( 1:256, bit, 'k');
axis( [0, 255, 0, 15] ); title( 'przydzial bitow' );
xlabel( 'numer podkanalu' ); ylabel( 'ilosc bitow' );

% etap 3, transmisja danych
clear adsl
trType = 2;                             % estymacja BER
[ teqIR, D ] = AdslTEQ( h, Le, Lp, 0 );
sir = conv( teqIR, h );
FEQ = fft( sir(1:N) );
FEQ = 1./ ( FEQ .* exp( j*2*pi/N * (0:N-1)*(D) ) );
FEQ = FEQ( 1:N/2 );
mask = bit;
ber = adsl( 16, trType, mask, teqIR, D, FEQ, 'AWGN' );

figure( 3 ); plot( ber );
title( 'liczba bledow w podkanalach' ); xlabel( 'nr podkanalu' );
ylabel( 'liczba blednie przeslanych symboli' );